      SUBROUTINE CLRDER
C
C  CALCULATE DYNAMIC DERIVATIVE CLR (ROLL DUE TO YAW RATE)
C      FOR BODY, WING, WING-BODY, AND WING-BODY-HORIZONAL-VERTICAL
C  CALCULATE VERTICAL TAIL CLP
C  CALCULATE BODY-HORIZONTAL-TAIL CLQ,CMQ,CLAD,CMAD,CYP,CNP, AND CNR
C  CALCULATE BODY-VERTICAL-TAIL CLQ,CMQ,CLAD,CMAD,CLP,CYP,CNP, AND CNR
C
      COMMON /OVERLY/ NLOG,NMACH,I,NALPHA
      COMMON /OPTION/ SREF,CBARR,ROUGFC,BLREF
      COMMON /CONSNT/ PI,DEG,UNUSED,RAD
      COMMON /FLGTCD/ FLC(93)
      COMMON /WINGD/  A(195)
      COMMON /WINGI/  WINGIN(77)
      COMMON /WBHCAL/ WBT(156)
      COMMON /SBETA/  STB(135), TRA(108), TRAH(108), STBH(135)
      COMMON /SUPWBB/  SWB(61),SHB(61)
      COMMON /IWING/  PWING,WING(400)
      COMMON /IVT/    PVT,VT(380)
      COMMON /IVF/    PVF,VF(380)
      COMMON /IBODY/  PBODY,BODY(400)
      COMMON /IBW/    PBW,BW(380)
      COMMON /IHT/    PHT, HT(380)
      COMMON /IBH/    PBH, BH(380)
      COMMON /IBV/    PBV, BV(380)
      COMMON /IBWHV/  PBWHV,BWHV(380)
      COMMON /IBWV /  PBWV,BWV(380)
      COMMON /FLOLOG/ FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1                HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2                TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3                HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4                VFPL,VFSC,CTAB
      LOGICAL  FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1         HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2         TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3         HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4         VFPL,VFSC,CTAB
      DIMENSION VAR(3),LGH(3),ROUTID(2),CLR(20),CLRWBT(20),
     1 X73210(20),Y73210(40),F73210(3),X73211(18),Y73211(36),F73211(3),
     2 UNITS(5),UNITI(5),OMEGA(5),ALPHA(20),CL(20)
      REAL MACH,LP,LPF
      DIMENSION STP(156)
      EQUIVALENCE(STP(1),WBT(1))
      EQUIVALENCE(ALPHA(1),FLC(23)),(CL(1),WING(21)),(CLR(1),WING(361)),
     1 (CLRWBT(1),BWHV(361))
      DATA ROUTID / 4HCLRD, 4HER  /
C
C     DATA FOR FIGURE 7.1.3.2-10
C
      DATA X73210/1.,2.,3.,4.,5.,6.,7.,8.,9.,10.,0.,.25,.5,1.,6*0./
      DATA Y73210/2.,3.3,3.9,4.2,4.5,4.8,4.9,4.95,5.,5.,3.,4.15,4.95,
     1 5.4,5.8,6.,6.2,6.4,6.45,6.5,3.95,5.5,6.25,6.8,7.15,7.45,7.75,
     2 7.8,7.9,7.95,5.,6.8,7.5,8.05,8.5,8.85,9.,9.15,9.2,9.25/
      DATA F73210/ 4H7.1., 4H3.2-, 4H10  /
C
C     DATA FOR FIGURE 7.1.3.2-11
C
      DATA X73211/2.,3.,4.,5.,6.,7.,8.,9.,10.,0.,.2,.4,99.,5*0./
      DATA Y73211/.0014,.00175,.00205,.0022,.00215,.0021,.00215,.00225,
     1 .00255,.0017,.0022,.0025,.00285,.0032,.00323,.00325,.00335,.0036,
     2 .002,.00245,.0028,.00315,.0035,.0036,.00375,.00397,.0043,
     3 .002,.00245,.0028,.00315,.0035,.0036,.00375,.00397,.0043/
      DATA F73211 / 4H7.1., 4H3.2-, 4H11  /
      DATA UNITS  /.025,.03,.03571428571,.04444444444,.056/
      DATA UNITI  /.05,.06,.07857142857,.1,.12/
      DATA OMEGA  /0.,15.,30.,45.,60./
C
      IF(.NOT. BO) GO TO 1010
C
C      SET BODY CLR DATA TO ZERO
C
      DO 1000 J=1,NALPHA
 1000 BODY(J+360)=0.0
 1010 CONTINUE
      IF(.NOT.SUBSON) GO TO 1060
      MACH=FLC(I+2)
      SWEC4=A(41)
      TAPRE=A(27)
      AR=A(7)
      GAMMA=STB(122)/RAD
      TWIST=WINGIN(11)
      LP=STB(11)
      ZP=STB(12)
      LPF=STBH(11)
      ZPF=STBH(12)
      DCYBV=VT(141)
      DCYBF=VF(141)
      IF(.NOT. WGPL)  GO TO 1040
      BEE=SQRT(1.-(MACH*COS(SWEC4))**2)
      AB=AR*BEE
      CS=COS(SWEC4)
      TS=TAN(SWEC4)
      CON=(1.+(AR*(1.-BEE**2)/(2.*BEE*(AB+2.*CS)))+(AB+2.*CS)/(AB+4.*CS)
     1     *TS**2/8.)/(1.+(AR+2.*CS)/(AR+4.*CS)*TS**2/8.)
      DCLRG=PI*AR*SIN(SWEC4)/(12.*(AR+4.*CS))
C
C---- FIGURE 7.1.3.2-10
C
      VAR(1)=AR
      VAR(2)=TAPRE
      LGH(1)=10
      LGH(2)=4
      CALL INTERX(2,X73210,VAR,LGH,Y73210,UNIT,10,40,1,1,0,0,1,1,0,0,
     1            F73210,3,ROUTID)
      DO 1020 J=1,4
         IF((SWEC4*RAD) .GE. OMEGA(J)) JJ=J
 1020 CONTINUE
      IF(SWEC4 .LT. 0.) GO TO 1040
      CLRCLO=(UNITI(JJ+1)-UNITI(JJ))/15.*(OMEGA(JJ+1)-SWEC4*RAD) -
     1       UNITI(JJ+1) + ((UNITS(JJ+1)-UNITS(JJ))/15.*(OMEGA(JJ+1)-
     2       SWEC4*RAD)-UNITS(JJ+1))*UNIT
C
C---- FIGURE 7.1.3.2-11
C
      VAR(1)=AR
      VAR(2)=TAPRE
      LGH(1)=9
      LGH(2)=4
      CALL INTERX(2,X73211,VAR,LGH,Y73211,DCLRT,9,36,0,0,0,0,0,0,0,0,
     1            F73211,3,ROUTID)
      CLRCLM=-CLRCLO*CON
C
C---- CLR VERSUS ALPHA
C
      DO 1030 J=1,NALPHA
         CLR(J)=(CL(J)*CLRCLM+DCLRG*GAMMA+DCLRT*TWIST)/RAD
         IF(.NOT. BO) GO TO 1030
C
C  SET IOM SINCE WING-BODY IS THE SAME AS WING ALONE
C
         BW(J+360)=CLR(J)
 1030 CONTINUE
 1040 IF(.NOT. (VTPL.OR.VFPL)) GO TO 1060
      DO 1050 J=1,NALPHA
         SA=SIN(ALPHA(J)*DEG)
         CA=COS(ALPHA(J)*DEG)
         IF(SWEC4 .LT. 0.) GO TO 1050
         CLRWBT(J)=CLR(J)
         IF(VTPL)CLRWBT(J)=CLRWBT(J)-2.*DCYBV*(LP*CA+ZP*SA)
     1           *(ZP*CA-LP*SA)/BLREF**2
         IF(VFPL)CLRWBT(J)=CLRWBT(J)-2.*DCYBF*(LPF*CA+ZPF*SA)
     1           *(ZPF*CA-LPF*SA)/BLREF**2
         IF(VTPL)VT(J+280)=2.*DCYBV*(ZP*CA-LP*SA)*(ZP*CA-LP*SA-ZP)/
     1           BLREF**2
         IF(VFPL)VF(J+280)=2.*DCYBV*(ZPF*CA-LPF*SA)*(ZPF*CA-LPF*SA-ZPF)/
     1           BLREF**2
         BWV(J+360)=CLRWBT(J)
         IF(VTPL) VT(J+360)=-2.*DCYBV*(LP*CA+ZP*SA)*(ZP*CA-LP*SA)/
     1            BLREF**2
         IF(VFPL) VF(J+360)=-2.*DCYBF*(LPF*CA+ZPF*SA)*(ZPF*CA-LPF*SA)
     1                    /BLREF**2
 1050 CONTINUE
 1060 IF(.NOT. BO) GO TO 1120
      IF(.NOT. HTPL) GO TO 1100
      IF(SUBSON)AKHB=WBT(1)
      IF(SUBSON)AKBH=WBT(2)
      IF(TRANSN)AKHB=SHB(35)
      IF(TRANSN)AKBH=SHB(11)
      IF(SUPERS)AKHB=STP(66)
      IF(SUPERS)AKBH=STP(65)
      IF(AKHB.EQ.UNUSED .OR. AKBH.EQ.UNUSED) GO TO 1080
C
C----- BODY-HORIZONTAL-TAIL CLQ,CMQ,CLAD,CMAD
C
      DO 1070 K=1,4
         KK=(K-1)*20+1
         IF(HT(KK+200).EQ.UNUSED .OR. BODY(KK+200).EQ.UNUSED) GO TO 1070
         BH(KK+200)=(AKBH+AKHB)*HT(KK+200)+BODY(KK+200)
 1070 CONTINUE
C
C----- BODY-HORIZONTAL-TAIL CYP,CNP,CNR
C
 1080 DO 1090 K=1,3
         KK=(K-1)*20+1
         IF(HT(KK+300).EQ.UNUSED .OR. BODY(KK+300).EQ. UNUSED)
     1            GO TO 1090
         BH(KK+300)=HT(KK+300)+BODY(KK+300)
 1090 CONTINUE
 1100 IF(.NOT. VTPL) GO TO 1120
C
C----- BODY-VERTICAL-TAIL CLQ,CMQ,CLAD,CMAD,CLP,CYP,CNR
C
      DO 1110 K=1,8
         KK=(K-1)*20+1
         IF((VT(KK+200).EQ.UNUSED .AND. VF(KK+200).EQ.UNUSED) .OR.
     1      BODY(KK+200).EQ.UNUSED) GO TO 1110
         BV(KK+200)=VT(KK+200)+BODY(KK+200)+VF(KK+200)
 1110 CONTINUE
 1120 CONTINUE
      RETURN
      END
