      SUBROUTINE DNPAWB
C
C     THIS ROUTINE YIELDS THE FOLLOWING WING-BODY DERIVATIVES-
C       SUB,TRAN,SUPER,HYPERSONIC-  CLQ
C                                   CMQ
C                                   CLADOT
C                                   CMADOT (NOT FOR TRANSONIC)
C
      REAL LAMDA,KWB,KBW,MACH
      COMMON /OVERLY/ NLOG,NMACH,IM,NALPHA
      COMMON /FLGTCD/ FLC(95)
      COMMON /SUPWBB/  SWB(61)
      COMMON /WINGI/  WINGIN(100)
      COMMON /IBW/    PBW,BW(380)
      COMMON /WINGD/  A(195)
      COMMON /IBODY/  PBODY,BODY(400)
      COMMON /IWING/  PWING,WING(400)
      COMMON /WHWB/   FF(182),WB(39)
      COMMON /FLOLOG/ FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1                HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,
     2                SUPERS,SUBSON,TRANSN,HYPERS,
     3                SYMFP,ASYFP,TRIMC,TRIM
      LOGICAL         FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1                HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,
     2                SUPERS,SUBSON,TRANSN,HYPERS,
     3                SYMFP,ASYFP,TRIMC,TRIM
      DIMENSION ROUTID(2)
      DIMENSION WTYPE(4)
      EQUIVALENCE(ASTRW,A(7)),(LAMDA,A(27))
      EQUIVALENCE(CLQWB,BW(201)),(CMQWB,BW(221)),(CLADWB,BW(241)),
     1           (CMADWB,BW(261))
      DATA WTYPE /4HSTRA,4HDOUB,4HCRAN,4HCURV/
      DATA ROUTID/4HDNPA,4HWB  /
      TYPE=WINGIN(15)
      MACH=FLC(IM+2)
      IF(SUBSON)GO TO 1000
      IF(TRANSN)GO TO 1010
      IF(HYPERS)GO TO 1020
      BETA=SQRT(MACH**2-1.)
      KWB=SWB(35)
      KBW=SWB(11)
      CLQW=WING(201)
      CLQB=BODY(201)
      CMQW=WING(221)
      CMQB=BODY(221)
      CLADW=WING(241)
      CLADB=BODY(241)
      CMADW=WING(261)
      CMADB=BODY(261)
      GO TO 1030
 1000 KWB=WB(2)
      KBW=WB(3)
      BETA=SQRT(1.-MACH**2)
      CLQW=WING(201)
      CLQB=BODY(201)
      CMQW=WING(221)
      CMQB=BODY(221)
      CLADW=WING(241)
      CLADB=BODY(241)
      CMADW=WING(261)
      CMADB=BODY(261)
      GO TO 1030
 1010 IF(TYPE.NE.WTYPE(1))GO TO 1040
      KWB=SWB(35)
      KBW=SWB(11)
      IF(MACH.GT.1.)BETA=SQRT(MACH**2-1.)
      IF(MACH.LT.1.)BETA=SQRT(1.-MACH**2)
      IF(MACH.EQ.1.)BETA=0.
      CLQW=WING(201)
      CLQB=BODY(201)
      CMQW=WING(221)
      CMQB=BODY(221)
      CLADW=WING(241)
      CLADB=BODY(241)
      CMADW=1000.
      CMADB=BODY(261)
      GO TO 1030
 1020 KWB=SWB(35)
      KBW=SWB(11)
      BETA=SQRT(MACH**2-1.)
      CLQW=WING(201)
      CLQB=BODY(201)
      CMQW=WING(221)
      CMQB=BODY(221)
      CLADW=WING(241)
      CLADB=0.
      CMADW=WING(261)
      CMADB=0.
 1030 CONTINUE
C
C    ---- WING-BODY PITCHING DERIVATIVES,CLQ,CMQ ----
C
      CLQWB=(KWB+KBW)*CLQW+CLQB
      CMQWB=(KWB+KBW)*CMQW+CMQB
C
C    ---- WING-BODY ACCELERATION DERIVATIVES,CLAD,CMAD ----
C
      BASTRW=BETA*ASTRW
      IF(.NOT.SUPERS .AND. BASTRW.LT.0.)RETURN
      IF(.NOT.SUPERS .AND. BASTRW.GT.4.)RETURN
      IF(.NOT.SUPERS .AND. LAMDA.NE.0.)RETURN
      CLADWB=(KWB+KBW)*CLADW+CLADB
      IF(CMADW.EQ.1000.)RETURN
      CMADWB=(KWB+KBW)*CMADW+CMADB
 1040 CONTINUE
      RETURN
      END
