      SUBROUTINE DPRESR(ZJ,ZWAKE,ALPHJ,DWANGL,QQINFY,MJ)
C
C***  CALCULATES NON-VISCOUS DYNAMIC PRESSURE AT HORIZONTAL TAIL
C
      DIMENSION ROUTID(2)
      LOGICAL ZUPPER
      LOGICAL TE
      REAL KN(6)
      REAL KNU(7),M(7),MACH
      REAL MJ
      DIMENSION C1(6),C2(6),THETA(7)
      DIMENSION SLOPE(6),X(6),Z(6),DKNU(7),VAR(4),LGH(4),QQ(7),QQPT(7)
      COMMON /CONSNT/ PI,DEG,UNUSED,RAD
      COMMON /SYNTSS/ SYNA(19)
      COMMON /SUPDW/  DWA(237)
      COMMON /WINGI/  WINGIN(100)
      COMMON /WINGD/  A(195)
      EQUIVALENCE (DELTE,DWA(235)),(THETE,DWA(236))
      EQUIVALENCE (THETA1,DWA(234)),(DLE,DWA(231)),(DELTAZ,DWA(232)),
     1            (XSUR,DWA(233))
      EQUIVALENCE (MACH,DWA(1)),(RL2,A(24))
      EQUIVALENCE (ZH,SYNA(7)),(ZW,SYNA(3)),(SLOPE(1),WINGIN(95)),
     1            (CR,WINGIN(6))
      DATA ROUTID/4HDPRE,4HSR  /
      DATA KN/0.0,0.2,0.4,0.6,0.8,1.0/
C
C  ***CALCULATE INTERSECTION OF MACH WAVES WITH SURVEY PLANE***
C
      QPT(XM) = 0.7*XM**2/(1.0+0.2*XM**2)**3.5
      TE=.FALSE.
      ZUPPER=.FALSE.
      ALPHA=ALPHJ
      ALPHA=ALPHA/RAD
      XSUR=(A(12)-(CR+RL2)*TAN(ALPHA))*SIN(ALPHA)+(RL2+CR)/COS(ALPHA)
      DELTAZ=CR*SIN(ALPHA)+(XSUR-CR*COS(ALPHA))*TAN(DWANGL)
      IF(ZJ.GT.0.0) ZUPPER=.TRUE.
      IF(ZUPPER)GO TO 1010
C
C                **TAIL BELOW WING***
C
      DLE=-ALPHA*RAD-SLOPE(1)
 1000 IF(DLE.GE.0.0)GO TO 1020
      GO TO 1040
C
C                ***TAIL ABOVE WING***
C
 1010 DLE= ALPHA*RAD-SLOPE(1)
      GO TO 1000
 1020 CONTINUE
C
C                ***EXPANSION***
C
      U=ATAN(1./SQRT(MACH**2-1.))
      ANG=U+ALPHA
      ARG1=XSUR*SIN(ALPHA)/TAN(ANG)
      ARG2=XSUR*COS(ALPHA)
      ARG3=SIN(ALPHA)+COS(ALPHA)/TAN(ANG)
      DO 1030 N=1,6
         X(N)= KN(N)*CR
         Z(N)= (-X(N)+ARG2-ARG1)/ARG3
         IF(ZUPPER)Z(N)=Z(N)+DELTAZ
 1030 IF(.NOT.ZUPPER)Z(N)=-ABS(Z(N))-DELTAZ
      GO TO 1080
 1040 CONTINUE
C
C                ***COMPRESSION***
C
      DELTA=ABS(DLE)
      MJ=UNUSED
 1050 CALL FIG68(MACH,DELTA,THETA1,IER)
      THETA(1)=THETA1
      IF(IER.NE.2)GO TO 1060
      DELTA=THETA1
      GO TO 1050
 1060 ANG=ALPHA-THETA(1)/RAD
      ARG1=XSUR*COS(ALPHA)-XSUR*SIN(ALPHA)/TAN(ANG)
      ARG2=SIN(ALPHA)+COS(ALPHA)/TAN(ANG)
      DO 1070 N=1,6
         X(N)=KN(N)*CR
         Z(N)= (-X(N)+ARG1)/ARG2
         IF(ZUPPER)Z(N)=ABS(Z(N))  +DELTAZ
         IF(.NOT.ZUPPER)Z(N)=Z(N)+DELTAZ
 1070 CONTINUE
      GO TO 1130
C
C  ***SUPERSONIC DYNAMIC PRESSURE RATIO***
C                ***EXPANSION***
 1080 NN=2
      DKNU(1)=DLE
      ARG2=SQRT(MACH**2-1.)
      ARG1=.40825*ARG2
      KNUINF=(2.4495*ATAN(ARG1)-ATAN(ARG2))*RAD
      KNU(1)=KNUINF+DKNU(1)
      CALL MACH2(KNU(1),M(1),IER)
      QQINF = QPT(MACH)
      QQPT(1) = QPT(M(1))
      QQ(1)=QQPT(1)/QQINF
 1090 I=NN
 1100 DKNU(I)=SLOPE(I-1)-SLOPE(I)
 1110 KNU(I)=KNU(I-1)+DKNU(I)
      CALL MACH2(KNU(I),M(I),IER)
      QQPT(I) = QPT(M(I))
      QQ(I)= QQPT(I)*QQ(I-1)/QQPT(I-1)
      IF(TE)GO TO 1210
 1120 I=I+1
      IF(I.LE.6)GO TO 1100
      GO TO 1190
C
C                ***COMPRESSION***
C
 1130 CONTINUE
      DKNU(1)=DLE
      ANG=(THETA(1)+DLE)/RAD
      ANG=ABS(ANG)
      QQ(1)=(MACH**2*SIN(THETA(1)/RAD)**2+5.0)/
     1      (6.0*MACH**2*SIN(ANG)**2)
      ARG1=(MACH*SIN(THETA(1)/RAD))**2+5.
      ARG2=7.*MACH**2*SIN(THETA(1)/RAD)**2-1.
      M(1)=(ARG1/ARG2)**.5/SIN(ANG)
      IF(M(1).LT.1.0) GO TO 1240
      ARG2=SQRT(M(1)**2-1.)
      ARG1=.40825*ARG2
      KNU(1)=(2.4495*ATAN(ARG1)-ATAN(ARG2))*RAD
 1140 I=2
 1150 CONTINUE
      DKNU(I)= SLOPE(I-1)-SLOPE(I)
      CALL FIG68(M(I-1),DKNU(I),THETA(I),IER)
      ARG=SIN(THETA(I)/RAD)**2
      IF(DKNU(I).GT.0.0)GO TO 1170
 1160 CONTINUE
      ANG=(THETA(I)+DKNU(I))/RAD
      ANG=ABS(ANG)
      QQ(I)=(M(I-1)**2*ARG+5.0)/(6.0*M(I-1)**2*SIN(ANG)**2)
      QQ(I)= QQ(I)*QQ(I-1)
      ARG1=(M(I-1)**2*ARG+5.)/(7.*M(I-1)**2*ARG-1.)
      M(I)= (ARG1**.5)/SIN(ANG)
      IF(TE)GO TO 1210
      GO TO 1180
 1170 QQPT(I-1) = QPT(M(I-1))
      ARG2=SQRT(M(I-1)**2-1.)
      ARG1=.40825*ARG2
      KNU(I-1)= (2.4495*ATAN(ARG1)-ATAN(ARG2))*RAD
      NN=I
      IF(TE)GO TO 1110
      GO TO 1090
 1180 I=I+1
      IF(I.LE.6)GO TO 1150
 1190 CONTINUE
C
C  ***CHECK FOR EXPANSION OR COMPRESSION AT THE TRAILING EDGE***
C
      TE=.TRUE.
      IF(M(6).LE.MACH) GO TO 1200
C
C  ***FLOW IS COMPRESSED TO FREESTREAM***
C
      I=7
      DKNU(I)=-ALPHA*RAD+SLOPE(6)
      DELTE=ABS(DKNU(I))
      CALL FIG68(M(6),DELTE,THETE,IER)
      IF(IER .NE. 2) GO TO 1195
        DKNU(I) = -THETE
        DELTE   = THETE
        CALL FIG68(M(6),DELTE,THETE,IER)
 1195 CONTINUE
      THETA(I)=THETE
      ARG=SIN(THETE/RAD)**2
      GO TO 1160
 1200 CONTINUE
C
C  ***FLOW IS EXPANDED TO FREESTREAM***
C
      I=7
      DKNU(I)=ALPHA*RAD+SLOPE(6)
      GO TO 1170
 1210 CONTINUE
C
C  ***FIND Q AND M AT ZJ***
C
      IF(ZJ/Z(6).LE.1.0)GO TO 1220
      I1=0
      I2=0
      CALL TBFUNX(ZJ,QQINFY,DYDX,6,Z,QQ,C1,I1,MI,NG,0,0,4HQNFY,1,ROUTID)
      CALL TBFUNX(ZJ,MJ,DYDX,6,Z,M,C2,I2,MI,NG,0,0,4HMJ  ,1,ROUTID)
      GO TO 1230
 1220 CONTINUE
      ARG=(ZJ-ZWAKE)/(Z(6)-ZWAKE)
      QQINFY=1.0+(QQ(7)-1.0)*ARG
      MJ=MACH
 1230 CONTINUE
      RETURN
 1240 MJ=M(1)
      RETURN
      END
