      SUBROUTINE DUMPRT
C
C***  THIS SUBROUTINE HANDLES THE DUMP LOGIC
C
C***  IDEAL OUTPUT MATRIX
C
C             BLOCK    PRINT     IOM
C             NAME     FLAG     ARRAY
C
      COMMON /IBODY/   PBODY,  BODY(400)
      COMMON /IWING/   PWING,  WING(400)
      COMMON /IHT/     PHT,    HT(380)
      COMMON /IVT/     PVT,    VT(380)
      COMMON /IVF/     PVF,    VF(380)
      COMMON /IBW/     PBW,    BW(380)
      COMMON /IBH/     PBH,    BH(380)
      COMMON /IBV/     PBV,    BV(380)
      COMMON /IBWH/    PBWH,   BWH(380)
      COMMON /IBWV/    PBWV,   BWV(380)
      COMMON /IBWHV/   PBWHV,  BWHV(380)
      COMMON /IPOWER/  PPOWER, POWER(200)
      COMMON /IDWASH/  PDWASH, DWASH(60)
C
      LOGICAL PBODY, PWING, PHT, PVT, PVF, PBW, PBH, PBV, PBWH, PBWV,
     1        PBWHV, PPOWER, PDWASH
C
C***  INPUT DATA BLOCKS
C
      COMMON /FLGTCD/ FLC(160)
      COMMON /OPTION/ OPTN(4)
      COMMON /SYNTSS/ SYNA(19)
      COMMON /BODYI/  BODYIN(129)
      COMMON /WINGI/  WINGIN(101)
      COMMON /VTI/    VTIN(154), TVTIN(8), VFIN(154)
      COMMON /HTI/    HTIN(154)
      COMMON /POWER/  PWIN(29), LBIN(21)
      COMMON /FLAPIN/ F(138)
C
C***  COMPUTATIONAL BLOCKS
C
      COMMON /WINGD/  A(195), B(49)
      COMMON /SBETA/  STB(135), TRA(108), TRAH(108), STBH(135)
      COMMON /BDATA/  BD(762)
      COMMON /WHWB/   FACT(182), WB(39), HB(39)
      COMMON /WBHCAL/ WBT(156)
      COMMON /HTDATA/ AHT(195), BHT(49)
      COMMON /VTDATA/ AVT(195), AVF(195)
      COMMON /WHAERO/ C(51), D(55), CHT(51), DHT(55), DVT(55), DVF(55)
      COMMON /POWR/   PW(315)
      COMMON /SUPWBB/  SWB(61), SHB(61)
      COMMON /SUPDW/  DWA(237)
      COMMON /SUPWH/  SLG(141), STG(141)
      COMMON /SUPBOD/ SBD(229)
      COMMON /LEVEL2/ SECOND(23)
C
      DIMENSION LB(200), STP(156), SLA(31), SLAH(31)
      DIMENSION XTYPE(4)
      EQUIVALENCE (DWA(1), LB(1)), (WBT(1), STP(1))
      EQUIVALENCE (STB(1), SLA(1)), (STB(32), SLAH(1))
C
C***   CONTROL DATA BLOCKS
C
      COMMON /FLOLOG/ FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1                HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2                TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3                HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4                VFPL,VFSC,CTAB
      COMMON /ERROR/  IERR,GONOGO,IEND,DMPALL,DPB,DPA,DPBD,DPAVF,
     1                DPFACT,DPWBT,DPBHT,DPAVT,DPAHT,DPC,DPD,DPWB,
     2                DPCHT,DPDHT,DPDYNH,SAVE,DMPCSE,DPDVT,DPGR,DPLB,
     3                DPPW,DPSTB,DPSBD,DPSLG,DPSWB,DPSTP,DPDWA,DPSTG,
     4                DPSLA,DPTRA,DPEXPD,DPDVF,DPFLP,DPFHG,DPFCM,DPTCD,
     5                DPFLA,DPTRM,DPSPR,DPTRN,DPTRM2,DPHYP,DPDYN,DPJET,
     6                DPHB,DPSHB,DPTRAH,DPSTBH,DPSEC,DPSLAH,DPINPT,
     7                DPFLC,DPOPTN,DPSYN,DPBDIN,DPWGIN,DPVTIN,DPTVT,
     8                DPVFIN,DPHTIN,DPPWIN,DPLBIN,DPF,DPIOM,
     9                DPIBDY,DPIWG,DPIHT,DPIVT,DPIVF,DPIBW,DPIBH,DPIBV,
     A                DPIBWH,DPIBWV,DPITOT,DPIPWR,DPIDWH
C
      LOGICAL  FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1         HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2         TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3         HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4         VFPL,VFSC,CTAB
      LOGICAL  IERR,GONOGO,IEND,DMPALL,DPB,DPA,DPBD,DPAVF,
     1         DPFACT,DPWBT,DPBHT,DPAVT,DPAHT,DPC,DPD,DPWB,
     2         DPCHT,DPDHT,DPDYNH,SAVE,DMPCSE,DPDVT,DPGR,DPLB,
     3         DPPW,DPSTB,DPSBD,DPSLG,DPSWB,DPSTP,DPDWA,DPSTG,
     4         DPSLA,DPTRA,DPEXPD,DPDVF,DPFLP,DPFHG,DPFCM,DPTCD,
     5         DPFLA,DPTRM,DPSPR,DPTRN,DPTRM2,DPHYP,DPDYN,DPJET,
     6         DPHB,DPSHB,DPTRAH,DPSTBH,DPSEC,DPSLAH,DPINPT,
     7         DPFLC,DPOPTN,DPSYN,DPBDIN,DPWGIN,DPVTIN,DPTVT,
     8         DPVFIN,DPHTIN,DPPWIN,DPLBIN,DPF,DPIOM,
     9         DPIBDY,DPIWG,DPIHT,DPIVT,DPIVF,DPIBW,DPIBH,DPIBV,
     A         DPIBWH,DPIBWV,DPITOT,DPIPWR,DPIDWH
      LOGICAL  LEQV(81)
C
      EQUIVALENCE (LEQV(1),IERR)
      DATA XTYPE / 4HSTRA, 4HDOUB, 4HCRAN, 4HCURV /
C
      DO 1000 I=1,4
      IF(WINGIN(15).EQ.XTYPE(I))WINGIN(15)=FLOAT(I)
      IF(  HTIN(15).EQ.XTYPE(I))  HTIN(15)=FLOAT(I)
      IF(  VTIN(15).EQ.XTYPE(I))  VTIN(15)=FLOAT(I)
      IF(  VFIN(15).EQ.XTYPE(I))  VFIN(15)=FLOAT(I)
 1000 CONTINUE
C
C
C***  DUMP LOGIC
C
      IF(.NOT. DMPALL) GO TO 1020
        DO 1010 I=5,81
          IF((I .EQ. 20) .OR. (I .EQ. 21)) GO TO 1020
          LEQV(I) = .TRUE.
 1010   CONTINUE
 1020 CONTINUE
C
C***  DUMP CASE LOGIC
C
      IF(.NOT. DMPCSE .OR. DMPALL) GO TO 1030
        DPA    = DPA    .OR. WGPL
        DPB    = DPB    .OR. (WGPL .AND. SUBSON)
        DPSTB  = DPSTB  .OR. ((BO .OR. WGPL .OR. VTPL .OR. TVTPAN)
     1                  .AND. (SUBSON .OR. TRANSN))
        DPTRA  = DPTRA  .OR. (WGPL .AND. TRANSN)
        DPTRAH = DPTRAH .OR. (HTPL .AND. TRANSN)
        DPSTBH = DPSTBH .OR. ((HTPL .OR. VTPL) .AND. (SUBSON .OR.
     1           TRANSN))
        DPBD   = DPBD   .OR. BO
        DPFACT = DPFACT .OR. ((WGPL .OR. HTPL) .AND. (SUBSON .OR.
     1                       (WINGIN(101) .GT. 2.5 .AND. .NOT. TRANSN)))
        DPWB   = DPWB   .OR. ((BO .AND. WGPL) .AND. (SUBSON .OR.
     1           TRANSN))
        DPHB   = DPHB   .OR. ((BO .AND. HTPL) .AND. (SUBSON .OR.
     1           TRANSN))
        DPWBT  = DPWBT  .OR. (WGPL .AND. HTPL .AND. SUBSON)
        DPAHT  = DPAHT  .OR. HTPL
        DPBHT  = DPBHT  .OR. (HTPL .AND. SUBSON)
        DPAVT  = DPAVT  .OR. VTPL
        DPAVF  = DPAVF  .OR. VFPL
        DPC    = DPC    .OR. (WGPL .AND. SUBSON)
        DPD    = DPD    .OR. (WGPL .AND. SUBSON)
        DPCHT  = DPCHT  .OR. (HTPL .AND. SUBSON)
        DPDHT  = DPDHT  .OR. (HTPL .AND. SUBSON)
        DPDVT  = DPDVT  .OR. (VTPL .AND. SUBSON)
        DPDVF  = DPDVF  .OR. (VFPL .AND. SUBSON)
        DPPW   = DPPW   .OR. ((PRPOWR .OR. JETPOW) .AND. SUBSON)
        DPSWB  = DPSWB  .OR. (BO .AND. WGPL .AND. .NOT. SUBSON)
        DPSHB  = DPSHB  .OR. (BO .AND. HTPL .AND. .NOT. SUBSON)
        DPDWA  = DPDWA  .OR. ((WGPL .AND. HTPL) .AND. (SUPERS .OR.
     1            HYPERS))
        DPSBD  = DPSWB  .OR. (BO .AND. (SUPERS .OR. HYPERS))
        DPSEC  = DPSEC  .OR. TRANSN
        DPSLG  = DPSLG  .OR. (WGPL .AND. .NOT. SUBSON)
        DPSTG  = DPSTG  .OR. (HTPL .AND. (SUPERS .OR. HYPERS))
        DPLB   = DPLB   .OR. LOASRT
        DPSTP  = DPSTP  .OR.  (((WGPL .AND. HTPL) .OR. VTPL .OR. VFPL)
     1            .AND. .NOT. SUBSON)
        DPSLA  = DPSLA  .OR. ((WGPL .OR. VTPL) .AND. (SUPERS .OR.
     1            HYPERS))
        DPSLAH = DPSLAH .OR. ((HTPL .OR. VFPL) .AND. (SUPERS .OR.
     1            HYPERS))
        DPINPT = .TRUE.
        DPIOM  = .TRUE.
 1030 CONTINUE
C
      IF(.NOT. DPINPT) GO TO 1040
        DPFLC  = .TRUE.
        DPOPTN = .TRUE.
        DPSYN  = .TRUE.
        DPBDIN = DPBDIN .OR. BO
        DPWGIN = DPWGIN .OR. (WGPL .OR. WGSC)
        DPVTIN = DPVTIN .OR. (VTPL .OR. VTSC)
        DPVFIN = DPVFIN .OR. (VFPL .OR. VFSC)
        DPTVT  = DPTVT  .OR. TVTPAN
        DPHTIN = DPHTIN .OR. (HTPL .OR. HTSC)
        DPPWIN = DPPWIN .OR. (PRPOWR .OR. JETPOW)
        DPLBIN = DPLBIN .OR. LOASRT
 1040 CONTINUE
C
      IF(.NOT. DPIOM) GO TO 1050
        DPIBDY = DPIBDY .OR. BO
        DPIWG  = DPIWG  .OR. WGPL
        DPIHT  = DPIHT  .OR. HTPL
        DPIVT  = DPIVT  .OR. VTPL .OR. TVTPAN
        DPIVF  = DPIVF  .OR. VFPL
        DPIBW  = DPIBW  .OR. (BO .AND. WGPL)
        DPIBH  = DPIBH  .OR. (BO .AND. HTPL)
        DPIBV  = DPIBV  .OR. (BO .AND. (VTPL .OR. VFPL .OR. TVTPAN))
        DPIBWH = DPIBWH .OR. (BO .AND. WGPL .AND. HTPL)
        DPIBWV = DPIBWV .OR. (BO .AND. WGPL .AND.
     1                        (VTPL .OR. VFPL .OR. TVTPAN))
        DPITOT = DPITOT .OR. (BO .AND. WGPL .AND. HTPL .AND.
     1                        (VTPL .OR. VFPL .OR. TVTPAN))
        DPIPWR = DPIPWR .OR. (PRPOWR .OR. JETPOW)
        DPIDWH = DPIDWH .OR. (WGPL .AND. HTPL)
 1050 CONTINUE
C
C***  DUMP COMPUTATIONAL ARRAYS
C
      IF(DPA)    CALL DMPARY(A,195,1HA,1)
      IF(DPAHT)  CALL DMPARY(AHT,195,3HAHT,3)
      IF(DPAVF)  CALL DMPARY(AVF,195,3HAVF,3)
      IF(DPAVT)  CALL DMPARY(AVT,195,3HAVT,3)
      IF(DPB)    CALL DMPARY(B,49,1HB,1)
      IF(DPBD)   CALL DMPARY(BD,762,2HBD,2)
      IF(DPBHT)  CALL DMPARY(BHT,49,3HBHT,3)
      IF(DPC)    CALL DMPARY(C,51,1HC,1)
      IF(DPCHT)  CALL DMPARY(CHT,51,3HCHT,3)
      IF(DPD)    CALL DMPARY(D,55,1HD,1)
      IF(DPDHT)  CALL DMPARY(DHT,55,3HDHT,3)
      IF(DPDVF)  CALL DMPARY(DVF,55,3HDVF,3)
      IF(DPDVT)  CALL DMPARY(DVT,55,3HDVT,3)
      IF(DPDWA)  CALL DMPARY(DWA,237,3HDWA,3)
      IF(DPFACT) CALL DMPARY(FACT,182,4HFACT,4)
      IF(DPHB)   CALL DMPARY(HB,39,2HHB,2)
      IF(DPLB)   CALL DMPARY(LB,200,2HLB,2)
      IF(DPPW)   CALL DMPARY(PW,315,2HPW,2)
      IF(DPSBD)  CALL DMPARY(SBD,229,3HSBD,3)
      IF(DPSEC)  CALL DMPARY(SECOND,23,4HSECD,4)
      IF(DPSHB)  CALL DMPARY(SHB,61,3HSHB,3)
      IF(DPSLA)  CALL DMPARY(SLA,31,3HSLA,3)
      IF(DPSLAH) CALL DMPARY(SLAH,31,4HSLAH,4)
      IF(DPSLG)  CALL DMPARY(SLG,141,3HSLG,3)
      IF(DPSTB)  CALL DMPARY(STB,135,3HSTB,3)
      IF(DPSTBH) CALL DMPARY(STBH,135,4HSTBH,4)
      IF(DPSTG)  CALL DMPARY(STG,141,3HSTG,3)
      IF(DPSTP)  CALL DMPARY(STP,156,3HSTP,3)
      IF(DPSWB)  CALL DMPARY(SWB,61,3HSWB,3)
      IF(DPTRA)  CALL DMPARY(TRA,108,3HTRA,3)
      IF(DPTRAH) CALL DMPARY(TRAH,108,4HTRAH,4)
      IF(DPWB)   CALL DMPARY(WB,39,2HWB,2)
      IF(DPWBT)  CALL DMPARY(WBT,156,3HWBT,3)
C
C***  DUMP INPUT ARRAYS
C
      IF(DPFLC .OR. DPOPTN .OR. DPSYN .OR. DPBDIN .OR. DPWGIN .OR.
     1   DPHTIN .OR. DPVTIN .OR. DPVFIN .OR. DPTVT .OR. DPPWIN .OR.
     2   DPLBIN) WRITE(6,1060)
 1060 FORMAT(52H0**** FOLLOWING ARE THE BASIC INPUT DATA BLOCKS ****)
      IF(DPFLC)  CALL DMPARY(FLC,160,3HFLC,3)
      IF(DPOPTN) CALL DMPARY(OPTN,4,4HOPTI,4)
      IF(DPSYN)  CALL DMPARY(SYNA,19,4HSYNA,4)
      IF(DPBDIN) CALL DMPARY(BODYIN,129,4HBDIN,4)
      IF(DPWGIN) CALL DMPARY(WINGIN,101,4HWGIN,4)
      IF(DPHTIN) CALL DMPARY(HTIN,154,4HHTIN,4)
      IF(DPVTIN) CALL DMPARY(VTIN,154,4HVTIN,4)
      IF(DPVFIN) CALL DMPARY(VFIN,154,4HVFIN,4)
      IF(DPTVT)  CALL DMPARY(TVTIN,8,3HTVT,3)
      IF(DPPWIN) CALL DMPARY(PWIN,29,4HPWIN,4)
      IF(DPLBIN) CALL DMPARY(LBIN,21,4HLBIN,4)
C
C***  DUMP IOM ARRAYS
C
      IF(DAMP) GO TO 1080
        IF(DPIBDY .OR. DPIWG .OR. DPIHT .OR. DPIVT .OR. DPIVF .OR.
     1     DPIBW .OR. DPIBH .OR. DPIBV .OR. DPIBWH .OR. DPIBWV .OR.
     2     DPITOT .OR. DPIPWR .OR. DPIDWH) WRITE(6,1070)
 1070   FORMAT(44H0**** FOLLOWING ARE THE IOM DATA BLOCKS ****)
        IF(DPIBDY) CALL DMPARY(BODY,400,4HBODY,4)
        IF(DPIWG)  CALL DMPARY(WING,400,4HWING,4)
        IF(DPIHT)  CALL DMPARY(HT,380,2HHT,2)
        IF(DPIVT)  CALL DMPARY(VT,380,2HVT,2)
        IF(DPIVF)  CALL DMPARY(VF,380,2HVF,2)
        IF(DPIBW)  CALL DMPARY(BW,380,2HBW,2)
        IF(DPIBH)  CALL DMPARY(BH,380,2HBH,2)
        IF(DPIBV)  CALL DMPARY(BV,380,2HBV,2)
        IF(DPIBWH) CALL DMPARY(BWH,380,3HBWH,3)
        IF(DPIBWV) CALL DMPARY(BWV,380,3HBWV,3)
        IF(DPITOT) CALL DMPARY(BWHV,380,4HBWHV,4)
        IF(DPIPWR) CALL DMPARY(POWER,200,4HPOWR,4)
        IF(DPIDWH) CALL DMPARY(DWASH,60,4HDWSH,4)
 1080 CONTINUE
C
      DO 1090 I=1,4
      IF(WINGIN(15).EQ.FLOAT(I))WINGIN(15)=XTYPE(I)
      IF(  HTIN(15).EQ.FLOAT(I))  HTIN(15)=XTYPE(I)
      IF(  VTIN(15).EQ.FLOAT(I))  VTIN(15)=XTYPE(I)
      IF(  VFIN(15).EQ.FLOAT(I))  VFIN(15)=XTYPE(I)
 1090 CONTINUE
      RETURN
      END
