      SUBROUTINE DWASH
C
C***  CALCULATES SUBSONIC DOWNWASH AT ANGLE OF ATTACK
C
      COMMON /FLGTCD/ FLC(95)
      COMMON /OVERLY/ NLOG,NMACH,I,NALPHA,IG
      COMMON /BDATA/  BD(762)
      COMMON /WINGD/  A(195), B(49)
      COMMON /WHWB/   FACT(182), WB(39)
      COMMON /WINGI/  CHRDTP,SSPNOP,SSPNE,SSPN,CHRDBP,CHRDR,SAVSI,SAVSO,
     1                CHSTAT,SWAFP,TWISTA,SSPNDD,DHDADI,DHDADO,
     2                TYPE,
     3                TOVC,DELTAY,XOVC,CLI,ALPHAI,CLALPA(20),
     4                CLMAX(20),CMO,LERI,LERO,CAMBER,TOVCO,XOVCO,CMOT,
     5                CLMAXL,CLAMO,TCEFF,KSHARP,XAC(20),ARCL,RSVD(2),
     6                SLOPE(6),TWASH
      COMMON /HTI/    HTIN(154)
      COMMON /IDWASH/ PDWASH, DWASHI(60)
      COMMON /IWING/  PWING, WING(400)
      COMMON /CONSNT/ PI, DEG, UNUSED, RAD
      COMMON /HTDATA/ AHT(195), BHT(49)
      COMMON /SYNTSS/ XCG,XW,ZW,ALIW,ZCG,XH,ZH,ALIH,XV,VERTUP,HINAX,
     1                XVF,SCALE,ZV,ZVF,YV,YF,PHIV,PHIF
      COMMON /OPTION/ SREF,CBARR,ROUGFC,BLREF
      DIMENSION ROUTID(2),ALPHA(21),DEDA(21)
      DIMENSION Q4157A(3),Q44155(2),Q4157B(3)
      DIMENSION X4157A(10),Y4157A(10)
      DIMENSION X157B2(14),X157B1(4),Y4157B(14,4)
      DIMENSION C4157A(6),CCLWJ(6),ANG(20)
      LOGICAL LESEPA,VERTUP
      EQUIVALENCE(SAC4,SWA4)
C
C     ----COMPUTE DOWNWASH ANGLES,SPAN OF VORTEX AT HORIZONTAL TAIL +
C     ----EFFECTIVE DISTANCE BETWEEN THE HORIZONTAL TAIL + THE VORTEX
C
      DATA ROUTID /4HDWAS,4HH   /
      DATA Q4157A/4H4.4.,4H1-68,4HA   /,Q44155/4H4.4.,4H1-66/
     1,Q4157B/4H4.4.,4H1-68,4HB   /
C
C     ----FIG 4.4.1-68A TYPE OF FLOW SEPARATION AS A FUNCTION OF AIRFOIL
C     ----AND WING SWEEP-SUBSONIC SPEEDS
C
      DATA X4157A /0.,19.,20.,25.,30.,35.,40.,45.,50.,54./
      DATA Y4157A /3*1.5,1.57,1.68,1.81,2.0,2.25,2.75,3./
C
C     ----FIGURE 4.4.1-68B AVERAGE DOWNWASH ACTING ON AFT LIFTING
C     ----SURFACE-LOW SPEEDS
C
      DATA X157B1 /.0,.2,.6,1./
      DATA X157B2 /.2,.3,.4,.5,.6,.7,.8,.833,1.,1.1 ,1.2,1.3,1.4,1.5/
      DATA Y4157B /1.,1.03,1.068,1.11,1.176,1.26,1.36,1.34,1.20,1.11,1.0
     1,.88,.74,.6  , .96,.96,.965,.976,.98,1.016,1.036,1.04,.946,.88,.8,
     2.69,.58,.46  , .74,.73,.72,.71,.69,.67,.644,.638,.582,.56,.52,.48,
     3.44,.4  ,   .5,.5,.5,.49,.476,.46,.448,.44,.4,.372,.352,.32,.3,.27
     4 /
      DATA I4157A /0/
      DATA M4157A /0/
      DATA ICLWJ /0/, MCLWJ /0/
C
      IDWASH = TWASH+0.5
      SWA4=A(40)
      TRRT=A(27)
      CORR=BD(77)
      TL2OB=A(24)/SSPN
      LESEPA=.FALSE.
C
C     ----FIG 4.4.1-68A TO DETERMINE IF LEADING OR TRAILING EDGE SEP.
C
      CALL TBFUNX(SAC4,TESTDY,DYDX,10,X4157A,Y4157A,C4157A,I4157A,M4157A
     1            ,NG,0,2,Q4157A,3,ROUTID)
      IF(TESTDY.GT.DELTAY) LESEPA=.TRUE.
      BVRUTP=0.78+0.10*(A(118)-0.40)+0.003*A(40)
      SRATIO=SREF/A(3)
      LEX=1
      DO 1000 J=1,NALPHA
 1000 ANG(J)=B(J+22)
      IF(A(126) .LT. ANG(1)) LEX=-1
C
C     ----LOOP ON ALPHA
C
      DO 1050 J=1,NALPHA
         ALP=FLC(J+22)+CORR
         NA=ABS(ALP)+1.5
         IF(NA .LT. 2)  NA=2
         IF(NA .GT. 21) NA=21
         XNA=NA-1
         DO 1040 K=1,NA
            ALPHA(K)=B(49)+(K-1)*(ALP-B(49))/XNA
            BJ22=A(126)+(K-1)*(ALP-A(126))/XNA
            ADOAD=ABS((BJ22-A(126))/(A(127)-A(126)))
            CALL TBFUNX(BJ22,CLWJ,CLAW,NALPHA,ANG,WING(21),CCLWJ,
     1                  ICLWJ,MCLWJ,NG,LEX,1,4HCLWJ,1,ROUTID)
            IF(LEX .LT. 0 .AND. BJ22 .LT. ANG(1))
     1              CLWJ=CLWJ*(BJ22-A(126))/(ANG(1)-A(126))
            CLWJ=SRATIO*CLWJ*WB(2)
C
C     ----FIGURE 4.4.1-66
C
           AEEFOA=TRRT/3.+(1.-TRRT/3.)*(1.4-(1.4-A(43)+.04*A(44))*ADOAD)
           TEST=.4/(1.4-A(43)+.04*A(44))
           IF(ADOAD .LT. TEST)AEEFOA=1.0
           AEFF=A(7)*AEEFOA
           BEFFOB=2.*AEEFOA/(1.+TRRT+(AEEFOA*(1.-TRRT)))
C
C  COMPUTE FIGURE 4.4.1-67 WITH COMPRESSIBILITY
C
            DEDAI=1.62*CLAW/(PI*AEFF)*RAD*SRATIO*WB(2)
            TZOB=TL2OB+SQRT(0.5*(-1.+SQRT(1.+4./AEFF**2)))
            DDEDAV=(1.-DEDAI)/(AEFF*TZOB*SQRT(1.+TZOB**2))
            DEDAV=DEDAI+DDEDAV
            BEFF=2.*SSPN*BEFFOB
C
C     ----COMPUTE LEFF
C
            BDFF=SSPN-SSPNDD
            BEFFO2=BEFF/2.
            IF(SSPNOP.LE.UNUSED)CTEFF=(CHRDTP-CHRDR)/SSPN*BEFFO2+CHRDR
            IF(SSPNOP.LE.UNUSED)GO TO 1010
            CTEFF=((CHRDTP-CHRDBP)/SSPNOP)*(SSPNOP-(SSPN-BEFFO2))+CHRDBP
 1010       CONTINUE
            EFFL=BEFFO2*A(62)+CTEFF/4.
            A(20)=A(24)-EFFL+CHRDR
            WFACT=A(20)
            IF(LESEPA)WFACT=A(24)+A(22)
            BVRU=BVRUTP*BEFF
            FACT(J+61)=A(12)-WFACT*(BJ22/RAD-0.41*CLWJ/(PI*AEFF))
     1                 -.5*BEFF*TAN(DHDADI/RAD)
            IF(BEFFO2.GT.BDFF) FACT(J+61)=A(12)-WFACT*(BJ22/RAD-0.41*
     1         CLWJ/(PI*AEFF))-(BDFF*TAN(DHDADI/RAD)+(BEFFO2-BDFF)
     2         *TAN(DHDADO/RAD))
            IF(CLWJ.EQ.0.0) GO TO 1020
            ERU=0.56*A(7)/CLWJ
            FACT(J+81)=BEFF-(BEFF-BVRU)*SQRT(ABS(A(20)/(SSPN*ERU)))
            GO TO 1030
 1020       FACT(J+81)=BEFF
 1030       BHOBV=2.*HTIN(4)/FACT(J+81)
            AOBVO2=ABS(2.*FACT(J+61)/FACT(J+81))
C
C     ----FIGURE 4.4.1-68B
C
            CALL TLINEX(X157B1,X157B2,Y4157B,4,14,AOBVO2,BHOBV,DEBODE,
     1                  1,2,1,2,Q4157B,3,ROUTID)
            IF(DEBODE.LT.0.)DEBODE=0.
            DEDA(K)=DEDAV
            IF(IDWASH .NE. 2) GO TO 1040
            XKA=1./A(7) - 1./(1.+A(7)**1.7)
            XKL=(10.-3.*A(27))/7.
            XLH=(XH-AHT(161)*COS(ALIH/RAD))-(XW-A(161)*COS(ALIW/RAD))
            XKH=(1.-ABS(0.5*A(12)/SSPNE))/(XLH/SSPNE)**(1./3.)
            DEDA(K)=4.44*(XKA*XKL*XKH*SQRT(A(43)))**1.19
 1040    CONTINUE
         DWASHI(J+40)=DEDA(NA)
         CALL TRAPZ(DEDA,NA,ALPHA,DWASHI(J+20),1)
         IF(IDWASH.NE.2)DWASHI(J+20)=DWASHI(J+20)*DEBODE
 1050 CONTINUE
C
C  COMPUTE D(EPSILON)/D(ALPHA) AT ALSCHD
C
      DO 1060 J=1,NALPHA
         CALL TBFUNX(FLC(J+22),Y,DWASHI(J+40),NALPHA,FLC(23),
     1               DWASHI(21),CCLWJ,IX,MX,NGX,1,1,4HDEDA,1,ROUTID)
 1060 CONTINUE
      RETURN
      END
