      SUBROUTINE FWDXAC(ATNSWP,TAPER,FACTOR,MACH,ROUTE,XAC)
C
C***  CALCULATES THE AERODYNAMIC CENTER OF SWEPT FORWARD WINGS
C
C***  INPUTS
C
C ATNSWP - ASPECT RATIO * TAN(SWEEP)
C  TAPER - EXPOSED TAPER RATIO
C FACTOR - TAN(SWEEP)/BETA
C   MACH - MACH NUMBER
C  ROUTE - CALLING SUBROUTINE NAME
C
C***  OUTPUT
C
C   XAC - AERODYNAMIC CENTER, ROOT CHORDS FROM ROOT CHORD L.E.
C
      COMMON /CONSNT/ PI,DEG,UNUSED,RAD
C
      DIMENSION SUBT1(36),SUBT2(36),SUBT3(36),SUBT4(36),SUBT5(36)
      DIMENSION SUBT6(36),SUBT7(36),SUBT8(36),SUBT9(36),SUBT10(36)
      DIMENSION SUBT11(36),SUBT12(36)
      DIMENSION SUPT1(36),SUPT2(36),SUPT3(36),SUPT4(36),SUPT5(36)
      DIMENSION SUPT6(36),SUPT7(36),SUPT8(36),SUPT9(36),SUPT10(36)
      DIMENSION SUPT11(36),SUPT12(36)
      DIMENSION TYSUBL(216),TYSUBR(216),TYSUPL(216),TYSUPR(216)
      DIMENSION TGRAPH(6),TCURVE(6),TX(6)
      DIMENSION ROUTE(2)
      DIMENSION Q41412(3),Q4222A(3),Q4222B(3)
C
      EQUIVALENCE (SUBT1 (1),TYSUBL(  1)),(SUBT2 (1),TYSUBL( 37))
      EQUIVALENCE (SUBT3 (1),TYSUBL( 73)),(SUBT4 (1),TYSUBL(109))
      EQUIVALENCE (SUBT5 (1),TYSUBL(145)),(SUBT6 (1),TYSUBL(181))
      EQUIVALENCE (SUBT7 (1),TYSUBR(  1)),(SUBT8 (1),TYSUBR( 37))
      EQUIVALENCE (SUBT9 (1),TYSUBR( 73)),(SUBT10(1),TYSUBR(109))
      EQUIVALENCE (SUBT11(1),TYSUBR(145)),(SUBT12(1),TYSUBR(181))
      EQUIVALENCE (SUPT1 (1),TYSUPL(  1)),(SUPT2 (1),TYSUPL( 37))
      EQUIVALENCE (SUPT3 (1),TYSUPL( 73)),(SUPT4 (1),TYSUPL(109))
      EQUIVALENCE (SUPT5 (1),TYSUPL(145)),(SUPT6 (1),TYSUPL(181))
      EQUIVALENCE (SUPT7 (1),TYSUPR(  1)),(SUPT8 (1),TYSUPR( 37))
      EQUIVALENCE (SUPT9 (1),TYSUPR( 73)),(SUPT10(1),TYSUPR(109))
      EQUIVALENCE (SUPT11(1),TYSUPR(145)),(SUPT12(1),TYSUPR(181))
C
      REAL MACH
C
      DATA Q41412 /4H4.1.,4H4.1-,4H5   /, Q4222A /4H4.1.,4H4.2-,4H26A /,
     1     Q4222B /4H4.1.,4H4.2-,4H26B /
C
      DATA TGRAPH / 0., .2, .25, .33, .5, 1. /
      DATA TCURVE / 1., 2., 3., 4., 5., 6. /
      DATA TX / 0., .2, .4, .6, .8, 1. /
C
C*** TAN(SWEEP)/BETA, TAPER=0.
C
      DATA SUBT1 /
     *  .08,  .04,  .02,  .01, 0.00, -.01,
     * -.01, -.03, -.05, -.06, -.07, -.08,
     * -.09, -.11, -.12, -.13, -.14, -.15,
     * -.18, -.19, -.20, -.21, -.22, -.22,
     * -.27, -.28, -.29, -.29, -.29, -.30,
     * -.36, -.37, -.37, -.38, -.38, -.38/
C
C*** TAN(SWEEP)/BETA, TAPER=.2
C
      DATA SUBT2 /
     *  .05,  .03,  .02,  .01, -.01, -.01,
     * -.06, -.07, -.08, -.09, -.10, -.10,
     * -.18, -.19, -.19, -.20, -.20, -.20,
     * -.30, -.31, -.31, -.31, -.31, -.31,
     * -.42, -.42, -.42, -.42, -.42, -.41,
     * -.54, -.54, -.54, -.53, -.53, -.52/
C
C*** TAN(SWEEP)/BETA, TAPER=.25
C
      DATA SUBT3 /
     *  .04,  .03,  .01, 0.00, -.01, -.02,
     * -.08, -.09, -.10, -.11, -.11, -.11,
     * -.21, -.21, -.21, -.21, -.22, -.22,
     * -.34, -.33, -.33, -.33, -.33, -.33,
     * -.46, -.46, -.46, -.45, -.44, -.44,
     * -.59, -.58, -.58, -.57, -.56, -.55/
C
C*** TAN(SWEEP)/BETA, TAPER=.33
C
      DATA SUBT4 /
     *  .04,  .03,  .01, 0.00, -.01, -.02,
     * -.10, -.10, -.11, -.11, -.12, -.12,
     * -.24, -.24, -.23, -.23, -.23, -.23,
     * -.38, -.37, -.37, -.36, -.36, -.36,
     * -.52, -.51, -.50, -.49, -.49, -.48,
     * -.66, -.65, -.64, -.63, -.62, -.61/
C
C*** TAN(SWEEP)/BETA, TAPER=.5
C
      DATA SUBT5 /
     *  .03,  .02,  .01, 0.00, -.01, -.02,
     * -.14, -.13, -.13, -.13, -.14, -.14,
     * -.31, -.30, -.29, -.28, -.28, -.27,
     * -.47, -.45, -.44, -.43, -.43, -.42,
     * -.64, -.62, -.60, -.59, -.57, -.56,
     * -.82, -.78, -.76, -.75, -.73, -.72/
C
C*** TAN(SWEEP)/BETA, TAPER=1.
C
      DATA SUBT6 /
     *  .01,  .02,  .01, 0.00, -.01, -.02,
     * -.24, -.21, -.20, -.20, -.19, -.19,
     * -.50, -.45, -.43, -.41, -.40, -.39,
     * -.75, -.69, -.65, -.63, -.62, -.60,
     *-1.00, -.94, -.90, -.86, -.84, -.82,
     *-1.25,-1.19,-1.13,-1.09,-1.06,-1.04/
C
C*** BETA/TAN(SWEEP), TAPER=0.
C
      DATA SUBT7 /
     * -.04, -.03, -.03, -.02, -.02, -.01,
     * -.10, -.09, -.09, -.09, -.08, -.08,
     * -.16, -.16, -.16, -.15, -.15, -.15,
     * -.23, -.23, -.23, -.23, -.22, -.22,
     * -.29, -.30, -.30, -.30, -.30, -.30,
     * -.37, -.37, -.37, -.37, -.38, -.38/
C
C*** BETA/TAN(SWEEP), TAPER=.2
C
      DATA SUBT8 /
     * -.05, -.05, -.04, -.03, -.02, -.01,
     * -.12, -.12, -.12, -.11, -.11, -.10,
     * -.21, -.21, -.21, -.21, -.21, -.20,
     * -.30, -.30, -.30, -.31, -.31, -.31,
     * -.40, -.40, -.40, -.41, -.41, -.41,
     * -.49, -.50, -.51, -.51, -.52, -.52/
C
C*** BETA/TAN(SWEEP), TAPER=.25
C
      DATA SUBT9 /
     * -.05, -.04, -.04, -.03, -.03, -.02,
     * -.12, -.12, -.12, -.12, -.12, -.11,
     * -.22, -.22, -.22, -.22, -.22, -.22,
     * -.32, -.32, -.32, -.32, -.33, -.33,
     * -.42, -.42, -.43, -.43, -.43, -.44,
     * -.52, -.53, -.53, -.54, -.55, -.55/
C
C*** BETA/TAN(SWEEP), TAPER=.33
C
      DATA SUBT10 /
     * -.04, -.04, -.03, -.03, -.02, -.02,
     * -.14, -.14, -.13, -.13, -.12, -.12,
     * -.23, -.23, -.24, -.23, -.23, -.23,
     * -.34, -.35, -.35, -.35, -.35, -.36,
     * -.46, -.46, -.46, -.47, -.48, -.48,
     * -.57, -.57, -.58, -.59, -.60, -.61/
C
C*** BETA/TAN(SWEEP), TAPER=.5
C
      DATA SUBT11 /
     * -.05, -.04, -.04, -.03, -.02, -.02,
     * -.15, -.15, -.15, -.14, -.14, -.14,
     * -.26, -.27, -.27, -.27, -.27, -.27,
     * -.39, -.40, -.40, -.41, -.41, -.42,
     * -.52, -.53, -.54, -.55, -.55, -.56,
     * -.66, -.67, -.68, -.70, -.71, -.72/
C
C*** BETA/TAN(SWEEP), TAPER=1.
C
      DATA SUBT12 /
     * -.07, -.06, -.05, -.04, -.03, -.02,
     * -.18, -.19, -.19, -.19, -.19, -.19,
     * -.35, -.36, -.37, -.37, -.38, -.39,
     * -.53, -.54, -.56, -.57, -.59, -.60,
     * -.73, -.74, -.76, -.78, -.80, -.82,
     * -.94, -.95, -.97, -.99,-1.02,-1.04/
C
C*** BETA/TAN(SWEEP), TAPER=0.
C
      DATA SUPT1 /
     * -.04, -.04, -.04, -.03, -.03, -.02,
     * -.10, -.10, -.09, -.08, -.07, -.05,
     * -.16, -.16, -.15, -.14, -.13, -.11,
     * -.23, -.23, -.22, -.21, -.20, -.18,
     * -.29, -.29, -.28, -.27, -.26, -.24,
     * -.37, -.37, -.36, -.35, -.33, -.31/
C
C*** BETA/TAN(SWEEP), TAPER=.2
C
      DATA SUPT2 /
     * -.04, -.04, -.04, -.04, -.03, -.01,
     * -.12, -.12, -.11, -.10, -.09, -.07,
     * -.20, -.20, -.20, -.19, -.18, -.15,
     * -.30, -.30, -.29, -.28, -.26, -.23,
     * -.40, -.40, -.39, -.37, -.34, -.30,
     * -.49, -.49, -.48, -.46, -.45, -.42/
C
C*** BETA/TAN(SWEEP), TAPER=.25
C
      DATA SUPT3 /
     * -.04, -.04, -.04, -.03, -.02, -.01,
     * -.12, -.12, -.11, -.10, -.08, -.05,
     * -.22, -.22, -.21, -.20, -.18, -.15,
     * -.31, -.31, -.30, -.29, -.27, -.23,
     * -.42, -.42, -.40, -.38, -.34, -.31,
     * -.51, -.51, -.50, -.47, -.43, -.38/
C
C*** BETA/TAN(SWEEP), TAPER=.33
C
      DATA SUPT4 /
     * -.04, -.04, -.04, -.03, -.01,  .02,
     * -.13, -.13, -.12, -.10, -.08, -.02,
     * -.23, -.23, -.22, -.20, -.18, -.14,
     * -.34, -.34, -.33, -.31, -.28, -.24,
     * -.45, -.45, -.43, -.41, -.38, -.35,
     * -.56, -.56, -.54, -.52, -.49, -.45/
C
C*** BETA/TAN(SWEEP), TAPER=.5
C
      DATA SUPT5 /
     * -.05, -.05, -.05, -.04, -.02,  .02,
     * -.14, -.14, -.12, -.10, -.07, -.03,
     * -.26, -.26, -.24, -.23, -.21, -.16,
     * -.39, -.39, -.37, -.35, -.32, -.28,
     * -.51, -.51, -.49, -.46, -.43, -.39,
     * -.65, -.65, -.63, -.62, -.60, -.58/
C
C*** BETA/TAN(SWEEP), TAPER=1.
C
      DATA SUPT6 /
     * -.08, -.08, -.08, -.04,  .02,  .08,
     * -.17, -.17, -.15, -.12, -.09, -.06,
     * -.34, -.34, -.32, -.29, -.27, -.24,
     * -.51, -.51, -.48, -.46, -.43, -.41,
     * -.71, -.71, -.68, -.56, -.64, -.63,
     * -.92, -.92, -.90, -.87, -.85, -.84/
C
C*** TAN(SWEEP)/BETA, TAPER=0.
C
      DATA SUPT7 /
     *  .22,  .20,  .10,  .03, 0.00, -.02,
     *  .13,  .13,  .12,  .04, -.02, -.05,
     *  .04,  .04,  .05, -.01, -.07, -.11,
     * -.04, -.04, -.03, -.07, -.14, -.18,
     * -.13, -.13, -.12, -.11, -.20, -.24,
     * -.22, -.22, -.21, -.17, -.26, -.31/
C
C*** TAN(SWEEP)/BETA, TAPER=.2
C
      DATA SUPT8 /
     *  .20,  .19,  .13,  .06,  .02, -.01,
     *  .08,  .09,  .03,  .03, -.03, -.07,
     * -.04, -.04, -.02, -.04, -.10, -.15,
     * -.17, -.16, -.14, -.12, -.19, -.23,
     * -.28, -.28, -.26, -.21, -.25, -.30,
     * -.40, -.39, -.38, -.36, -.37, -.42/
C
C*** TAN(SWEEP)/BETA, TAPER=.25
C
      DATA SUPT9 /
     *  .19,  .20,  .15,  .08,  .02, -.01,
     *  .06,  .07,  .08,  .04, -.01, -.05,
     * -.07, -.06, -.03, -.05, -.10, -.15,
     * -.19, -.18, -.16, -.13, -.19, -.23,
     * -.32, -.31, -.29, -.29, -.27, -.31,
     * -.44, -.44, -.43, -.40, -.33, -.38/
C
C*** TAN(SWEEP)/BETA, TAPER=.33
C
      DATA SUPT10 /
     *  .18,  .19,  .16,  .11,  .06,  .02,
     * 0.00,  .05,  .06,  .07,  .04, -.02,
     * -.09, -.08, -.06, -.05, -.10, -.14,
     * -.19, -.18, -.16, -.16, -.19, -.24,
     * -.37, -.37, -.34, -.29, -.30, -.35,
     * -.51, -.51, -.49, -.45, -.41, -.45/
C
C*** TAN(SWEEP)/BETA, TAPER=.5
C
      DATA SUPT11 /
     *  .18,  .19,  .16,  .11,  .06,  .02,
     *  .02,  .03,  .05,  .04, 0.00, -.03,
     * -.15, -.14, -.11, -.09, -.12, -.16,
     * -.32, -.31, -.28, -.23, -.24, -.28,
     * -.48, -.48, -.45, -.40, -.35, -.39,
     * -.65, -.65, -.62, -.57, -.55, -.58/
C
C*** TAN(SWEEP)/BETA, TAPER=1.
C
      DATA SUPT12 /
     *  .19,  .20,  .19,  .16,  .12,  .08,
     * -.05, -.03, -.01, -.01, -.03, -.06,
     * -.30, -.29, -.25, -.20, -.22, -.24,
     * -.55, -.54, -.50, -.42, -.39, -.41,
     * -.80, -.79, -.75, -.67, -.67, -.63,
     *-1.05,-1.04,-1.00, -.92, -.84, -.84/
      AFACT=ABS(FACTOR)
      AATNSP=ABS(ATNSWP)
C
      IF(AFACT .NE. 0.) FACTI=1./AFACT
      IF(AFACT .EQ. 0.) FACTI=1.E10
C
      IF(MACH .LT. 1. .AND. AFACT .LE. 1.)
     1  CALL TLIN3X(TCURVE,TX,TGRAPH,TYSUBL,6,6,6,AATNSP,AFACT,
     2              TAPER,XAC,2,0,0,2,0,0,Q4222A,3,ROUTE)
C
      IF(MACH .LT. 1. .AND. AFACT .GT. 1.)
     1  CALL TLIN3X(TCURVE,TX,TGRAPH,TYSUPR,6,6,6,AATNSP,FACTI,
     2              TAPER,XAC,2,0,0,2,0,0,Q4222B,3,ROUTE)
C
      IF(MACH .GE. 1. .AND. AFACT .GT. 1.)
     1  CALL TLIN3X(TCURVE,TX,TGRAPH,TYSUPL,6,6,6,AATNSP,FACTI,
     2              TAPER,XAC,2,0,0,2,0,0,Q4222B,3,ROUTE)
C
      IF(MACH .GE. 1. .AND. AFACT .LE. 1.)
     1  CALL TLIN3X(TCURVE,TX,TGRAPH,TYSUPR,6,6,6,AATNSP,AFACT,
     2              TAPER,XAC,2,0,0,2,0,0,Q4222A,3,ROUTE)
C
      RETURN
      END
