      SUBROUTINE GDELTA(GD1,GD2,GD3,EFI,EFO,BOCH,SB)
C
C***  CALCULATES FLAP SPANWISE LOADING COEFFICIENT G/DELTA
C
      LOGICAL ASYFP
      COMMON /FLOLOG/ X(20),ASYFP
      COMMON /HTDATA/ AHT(195)
      COMMON /SUPDW/  DW(35),TCD(58)
      COMMON /HTI/    HTIN(131)
      EQUIVALENCE (GD1H,TCD(43)),(GD2H,TCD(44)),(GD3H,TCD(45)),
     1    (GD4H,TCD(46)),(TANTE,AHT(80)),(TANLE,AHT(62)),(BO2H,HTIN(4)),
     2    (BSTO2,HTIN(3)),(CRH,AHT(10))
      DIMENSION FGX(48),ZRX(60),C1(6),C2(6),C3(6),C4(6)
      EQUIVALENCE (ZRX(13),FGX(1))
      DIMENSION GD1(14),GD2(14),GD3(14),SPU(14),X1(5),GNA(2)
      DIMENSION GD(17),A(16),EQ(16),CN(48),FGC(36),SPT(9),GI(12),
     1         SD(5),C(6),BOCH(4)
      DATA ZRX/60*0./,I1/0/,I2/0/,I3/0/,I4/0/
      DATA X1/0.,.195,.556,.831,1.0/,GNA/4HGDEL,4HTA  /
      DATA SPU/0.,.1423,.2817,.4153,.5407,.6549,.7557,.8412,.9097,.9595,
     1.9898,1.000,.5,.75/
      DATA SD/0.,.383,.707,.924,1.0/,IN/0/,GD/17*0.0/
      DATA SPT/0.,.195,.383,.556,.707,.831,.924,.981,1.0/
      DATA EQ /-.017,.029,-.014,.988 , .032,-.003,.994,.976 ,-.041,1.021
     1         ,.955,1.040 , 4*1.0 /
      DATA CN / .05775384,-.1585488,.6190800,.5162876,-.1332188,.5903109
     1 ,.6376293,-.09812725,.5287240,.6979618,-.2243549,.05177605,
     2  .8184079,-.2989922,.1550801,.03851272,.04523051,-.1196368,
     3  .4375114,.6320983,-.1533014,.6545052,.6621265,-.1765276,
     4  .5301887,.6743488,-.2033035,.08116567, .8319939,-.2928609,
     5  .1422650,.06120639,.03238602,-.07837254,.4212096,.6365698,
     6 -.1345339,.5254995,.7812855,-.2178882,.5871445,.6832385,
     7 -.3022919,.1264219,.7802445,-.2512727,.1793873,.08073133 /
      IF(ASYFP)GO TO 1140
 1000 CALL AGENR(BOCH,SB,A)
C
C     ----SOLVE SIMULATANEOUS EQUATIONS.
C
      DO 1010 I=1,16,4
         CALL SIMUL4(A    ,EQ(I),GD(I))
 1010 CONTINUE
 1020 IF(ASYFP)GO TO 1160
C
C     ----COMPUTE INTERMEDIATE POINTS.
C
      LL=1
      DO 1050 I=1,3
         DO 1040 J=1,4
            KJ=16*(I-1)
            GIM=0.
            DO 1030 L=1,4
               M=4*(I-1)+L
               K=4*(J-1)+KJ+L
               GIM=GIM+CN(K)*GD(M)
 1030       CONTINUE
            GI(LL)=GIM
            LL=LL+1
 1040    CONTINUE
 1050 CONTINUE
      I=1
      J=4
      DO 1070 LL=5,17,4
         K=1
         DO 1060 L=I,J
            FGC(L)=GD(LL-K)
            K=K+1
 1060    CONTINUE
         I=I+4
         J=J+4
 1070  CONTINUE
      DO 1080 J=1,16
         GD(J)=FGC(J)
 1080 CONTINUE
C
C     ----COMPUTE INTERMEDIATE POINTS FOR 4TH CURVE.
C
      DO 1090 L=2,8,2
         CALL TBFUNX(SPT(L),FGC(L+27),LL,5,SD,GD(13),C,IN,MI,LL,0,0,
     1               4HGDEL,1,4HGDEL)
 1090 CONTINUE
C
C     ----CONSTRUCT TOTAL CURVE.
C
      J=1
      LL=1
      DO 1100 L=1,16
         FGC(LL)=GD(L)
         IF(L.LT.13)FGC(LL+1)=GI(L)
         LL=LL+2
         J=J+1
         IF(J.LT.5)GO TO 1100
         FGC(LL)=0.
         LL=LL+1
         J=1
 1100 CONTINUE
C
C     ----USE LINEAR FOR LAST INTERPOLATED POINT.
C
      DO 1110 I=8,35,9
         FGC(I)=.25*FGC(I-1)
 1110 CONTINUE
C
C     ----GENERATE FINAL CURVES.
C
      SPU(13)=EFI
      SPU(14)=EFO
      II=0
      I1=0
      I2=0
      I3=0
      I4=0
      DO 1120 L=1,12
         CALL TBFUNX(SPU(L),FGX(L)   ,LL,9,SPT,FGC( 1),C1,I1,MI,LL,0,0,
     1               4HGDL1,1,GNA)
         CALL TBFUNX(SPU(L),FGX(L+12),LL,9,SPT,FGC(10),C2,I2,MI,LL,0,0,
     1               4HGDL2,1,GNA)
         CALL TBFUNX(SPU(L),FGX(L+24),LL,9,SPT,FGC(19),C3,I3,MI,LL,0,0,
     1               4HGDL3,1,GNA)
         CALL TBFUNX(SPU(L),FGX(L+36),LL,9,SPT,FGC(28),C4,I4,MI,LL,0,0,
     1               4HGDL4,1,GNA)
 1120 CONTINUE
      DO 1130 L=1,14
         CALL TBFUNX(SPU(L),GD1(L),LL,9,SPT,FGC(28),C,II,MI,LL,0,0,
     1              4HGDL1,1,GNA)
         CALL TLINEX(X1,SPU,ZRX,5,12,EFI,SPU(L),GD2(L),0,0,0,0,4HGXL2,
     1               1,GNA)
         CALL TLINEX(X1,SPU,ZRX,5,12,EFO,SPU(L),GD3(L),0,0,0,0,4HGXL3,
     1               1,GNA)
 1130 CONTINUE
C
      RETURN
C
 1140 ARG1=(TANTE-TANLE)*BSTO2
      DO 1150 I=1,4
         NMU=5-I
         CC=CRH+SD(NMU)*ARG1
         BOCH(I)=2.*BSTO2/CC
 1150 CONTINUE
      GO TO 1000
 1160 GD1H=GD(16)
      GD2H=GD(15)
      GD3H=GD(14)
      GD4H=GD(13)
      RETURN
      END
