      SUBROUTINE OUTPUT
C
C     OUTPUT CONTROLS THE PRINTING OF STATIC AND DYNAMIC
C     STABILITY DATA STORED IN THE IDEAL OUTPUT MATRIX
C
C         SUBROUTINES REFERENCED-
C              1- HEADR - WRITES PAGE HEADINGS, PASSES STABILITY
C                         DATA TO INTERM, AND WRITES REQUIRED
C                         NOTES FOLLOWING DATA.
C              2- PRCSID- WRITES THE USER SUPPLIED IDENTIFICATION
C                         CENTERED ON THE PAGE.
C              3- INTERM- COMPUTES AERODYNAMIC CENTER OF PRESSURE
C                         FOR STATIC STABILITY DATA, SETS PRINT
C                         FORMAT, AND CALLS SWRITE.
C              4- SWRITE- PRINTS DATA WITH BLANKS, NDM, OR NA
C                         REPLACING NUMERIC DATA WHERE APPLICABLE.
C
      COMMON /IBODY/  PBODY,  BODY(400)
      COMMON /IWING/  PWING,  WING(400)
      COMMON /IHT/    PHT,    HT(380)
      COMMON /IVT/    PVT,    VT(380)
      COMMON /IVF/    PVF,    VF(380)
      COMMON /IBW/    PBW,    BW(380)
      COMMON /IBH/    PBH,    BH(380)
      COMMON /IBV/    PBV,    BV(380)
      COMMON /IBWH/   PBWH,   BWH(380)
      COMMON /IBWV/   PBWV,   BWV(380)
      COMMON /IBWHV/  PBWHV,  BWHV(380)
      COMMON /IPOWER/ PPOWER
      COMMON /OPTION/ SREF, CBARR, ROUGFC, BLREF
      COMMON /CONSNT/ CONST(4)
      COMMON /SUPDW/  DWA(237)
      COMMON /FLGTCD/ FLC(160)
      COMMON /OVERLY/ NLOG,NMACH,I,NALPHA,IG,NF,LF,K
      COMMON /CASEID/ IDCASE(74),KOUNT,NAMSV(100),IDIM
      COMMON /FLOLOG/ FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1                HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2                TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3                HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4                VFPL,VFSC,CTAB
C
      LOGICAL  FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1         HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2         TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3         HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4         VFPL,VFSC,CTAB
      LOGICAL PBODY,PWING,PHT,PVT,PVF,PBW,PBH,PBV,PBWH,PBWV,PBWHV
      LOGICAL PWOP,PWP,GROUND,PPOWER,FLAG
      EQUIVALENCE (DWA(237),JDETCH),(CONST(3),UNUSED)
      EQUIVALENCE (WT,FLC(157))
      DIMENSION WTI(4)
      DATA WTI / 4H LB., 4H LB., 4H N. , 4H N.  /
C
      IF(PBODY)LAST=1
      IF(PWING)LAST=2
      IF(PHT)LAST=3
      IF(PVT)LAST=4
      IF(PVF)LAST=4
      IF(PBW)LAST=5
      IF(PBH)LAST=6
      IF(PBV)LAST=7
      IF(PBWH)LAST=8
      IF(PBWV)LAST=9
      IF(PBWHV)LAST=10
      GROUND=.FALSE.
      NALPHA=FLC(2) + 0.5
      IF(FLC(63) .NE. UNUSED) GROUND = .TRUE.
      IF(.NOT. SUPERS)   JDETCH = NALPHA
      IF(JDETCH .EQ. -1) JDETCH = NALPHA
      IF(JDETCH .EQ. 0)  JDETCH = 1
C
C     ----- PRINT BODY DATA
C
      FLAG = PBODY .OR. (BUILD .AND. BO)
      IF(.NOT. FLAG)GO TO 1000
        PWOP=(LAST.EQ.1).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.1)
        IF(PWOP)CALL HEADR(BODY,1,1,21,GROUND,.FALSE.,.FALSE.)
        IF(PWP) CALL HEADR(BODY,1,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(BODY(201),1,2,21,.FALSE.,.FALSE.,.FALSE.)
 1000 CONTINUE
C
C     ----- PRINT WING DATA
C
      FLAG = PWING .OR. (BUILD .AND. WGPL)
      IF(.NOT. FLAG)GO TO 1010
        PWOP=(LAST.EQ.2).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.2)
        IF(PWOP)CALL HEADR(WING,2,1,21,GROUND,.FALSE.,.FALSE.)
        IF(PWP) CALL HEADR(WING,2,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(WING(201),2,2,21,.FALSE.,.FALSE.,.FALSE.)
 1010 CONTINUE
C
C     ----- PRINT HORIZONTAL TAIL DATA
C
      FLAG = PHT .OR. (BUILD .AND. HTPL)
      IF(.NOT. FLAG)GO TO 1020
        PWOP=(LAST.EQ.3).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.3)
        IF(PWOP)CALL HEADR(HT,3,1,21,GROUND,.FALSE.,.FALSE.)
        IF(PWP) CALL HEADR(HT,3,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(HT(201),3,2,21,.FALSE.,.FALSE.,.FALSE.)
 1020 CONTINUE
C
C     ----- PRINT VERTICAL TAIL DATA
C
      FLAG = PVT .OR. (BUILD .AND. VTPL)
      IF(.NOT. FLAG)GO TO 1030
        PWOP=(LAST.EQ.4).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.4)
        IF(PWOP)CALL HEADR(VT,4,1,21,GROUND,.FALSE.,.TRUE.)
        IF(PWP) CALL HEADR(VT,4,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(VT(201),4,2,21,.FALSE.,.FALSE.,.TRUE.)
 1030 CONTINUE
C
C     ----- PRINT VENTRAL FIN DATA
C
      FLAG = PVF .OR. (BUILD .AND. VFPL)
      IF(.NOT. FLAG)GO TO 1040
        PWOP=(LAST.EQ.4).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.4)
        IF(PWOP)CALL HEADR(VF,11,1,21,GROUND,.FALSE.,.TRUE.)
        IF(PWP) CALL HEADR(VF,11,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(VF(201),11,2,21,.FALSE.,.FALSE.,.TRUE.)
 1040 CONTINUE
C
C     ----- PRINT BODY-WING DATA
C
      FLAG = PBW .OR. (BUILD .AND. BO .AND. WGPL)
      IF(.NOT. FLAG)GO TO 1050
        PWOP=(LAST.EQ.5).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.5)
        IF(PWOP)CALL HEADR(BW,5,1,21,GROUND,.FALSE.,.FALSE.)
        IF(PWP) CALL HEADR(BW,5,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(BW(201),5,2,21,.FALSE.,.FALSE.,.FALSE.)
 1050 CONTINUE
C
C     ----- PRINT BODY-HORIZONTAL TAIL DATA
C
      FLAG = PBH .OR. (BUILD .AND. BO .AND. HTPL)
      IF(.NOT. FLAG)GO TO 1060
        PWOP=(LAST.EQ.6).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.6)
        IF(PWOP)CALL HEADR(BH,6,1,21,GROUND,.FALSE.,.FALSE.)
        IF(PWP) CALL HEADR(BH,6,1,21,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(BH(201),6,2,21,.FALSE.,.FALSE.,.FALSE.)
 1060 CONTINUE
C
C     ----- PRINT BODY-VERTICAL TAIL DATA
C
      FLAG = PBV .OR. (BUILD .AND. BO .AND. VTPL)
      IF(.NOT. FLAG)GO TO 1070
        PWOP=(LAST.EQ.7).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.7)
        IF(PWOP)CALL HEADR(BV,7,1,21,GROUND,.FALSE.,.TRUE.)
        IF(PWP) CALL HEADR(BV,7,1,21,GROUND,.TRUE.,.TRUE.)
        IF(DAMP)CALL HEADR(BV(201),7,2,21,.FALSE.,.FALSE.,.TRUE.)
 1070 CONTINUE
C
C     ----- PRINT B-W-H DATA
C
      FLAG = PBWH .OR. (BUILD .AND. BO .AND. WGPL .AND. HTPL)
      IF(.NOT. FLAG)GO TO 1080
        PWOP=(LAST.EQ.8).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.8)
        IF(PWOP)CALL HEADR(BWH,8,1,JDETCH,GROUND,.FALSE.,.FALSE.)
        IF(PWP) CALL HEADR(BWH,8,1,JDETCH,GROUND,.TRUE.,.FALSE.)
        IF(DAMP)CALL HEADR(BWH(201),8,2,JDETCH,.FALSE.,.FALSE.,.FALSE.)
 1080 CONTINUE
C
C     ----- PRINT B-W-V DATA
C
      FLAG = PBWV .OR. (BUILD .AND. BO .AND. WGPL .AND. VTPL)
      IF(.NOT. FLAG)GO TO 1090
        PWOP=(LAST.EQ.9).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.9)
        IF(PWOP)CALL HEADR(BWV,9,1,21,GROUND,.FALSE.,.TRUE.)
        IF(PWP) CALL HEADR(BWV,9,1,21,GROUND,.TRUE.,.TRUE.)
        IF(DAMP)CALL HEADR(BWV(201),9,2,JDETCH,.FALSE.,.FALSE.,.TRUE.)
 1090 CONTINUE
C
C     ----- PRINT B-W-H-V DATA
C
      IF(.NOT.PBWHV)GO TO 1100
        PWOP=(LAST.EQ.10).AND.PPOWER.AND..NOT.BUILD
        PWOP=.NOT.PWOP
        PWP=PPOWER.AND.(LAST.EQ.10)
        IF(PWOP)CALL HEADR(BWHV,10,1,JDETCH,GROUND,.FALSE.,.TRUE.)
        IF(PWP) CALL HEADR(BWHV,10,1,JDETCH,GROUND,.TRUE.,.TRUE.)
        IF(DAMP)CALL HEADR(BWHV(201),10,2,JDETCH,.FALSE.,.FALSE.,.TRUE.)
 1100 CONTINUE
      IF((WT .EQ. UNUSED) .OR. (FLC(K+73) .EQ. UNUSED)) GO TO 1120
        IF(IDIM.GT.2) WT=WT/0.2248089
        Q  = 0.7*FLC(K+73)*FLC(I+2)**2
        CL = WT/(Q*SREF)
        WRITE(6,1110) WT, WTI(IDIM), CL
 1110   FORMAT(22H0*** VEHICLE WEIGHT = ,F9.2,A4/
     1         36H0*** LEVEL FLIGHT LIFT COEFFICIENT =,F8.5)
 1120 CONTINUE
      RETURN
      END
