      SUBROUTINE SSHING
C
C    ---THIS SUBROUTINE CALCULATES THE SUPERSONIC HINGE MOMENT
C       DERIVATIVE FOR FLAT SIDED AND SYMMETRIC BI-CONVEX CONTROLS
C       AND THE AREA MOMENT ABOUT THE HINGE LINE.
C
      COMMON /OVERLY/ NLOG,NMACH,IM,NALPHA
      COMMON /CONSNT/ PI,DR,UNUSED,RAD
      COMMON /FLGTCD/ FLC(93)
      COMMON /FLAPIN/ F(69)
      COMMON /WINGD/  A(195)
      COMMON /HTDATA/ AHT(195)
      COMMON /WINGI/  WINGIN(77)
      COMMON /HTI/    HTIN(131)
      COMMON /IWING/  PWING, WING(400)
      COMMON /POWR/   SPR(59)
      COMMON /OPTION/ SREF,CBARR,RUFF,BLREF
      COMMON /IHT/    PHT, HT(380)
      COMMON /FLOLOG/ FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1       HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,TRANSN,
     2       HYPERS,SYMFP,ASYFP,TRIMC,TRIM
      REAL LAMHL,LAMHLD
      REAL K,K3
      REAL MU,MACH
      LOGICAL INBORD
      LOGICAL TAPERD
      LOGICAL TRANSL
      LOGICAL FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1        HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,TRANSN,
     2        HYPERS,SYMFP,ASYFP,TRIMC,TRIM
      DIMENSION ITRANS(5)
      DIMENSION CPO(10)
      DIMENSION CPI(10),SWF(4),CFACTR(4)
      DIMENSION ETA(5),CF(10),CHRD(5), CFACT(10),CLALDS(10)
      DIMENSION CP(10),CPOCF(4)
      EQUIVALENCE (CPI,F(39)),(CPO,F(49))
      EQUIVALENCE (ALOCI,BIF,F(14)),(ALOCO,BOF,F(15)),(BO2,SSPN)
      EQUIVALENCE (LAMHLD, SPR(4)),(PHITE,SPR(5))
      EQUIVALENCE (TRTOFL,SPR(35))
      EQUIVALENCE (CFI,F(12)),(CFO,F(13))
      EQUIVALENCE (CO,SPR(36))
      EQUIVALENCE (K3,SPR(6)),(C1,SPR(2)),(C2,SPR(3))
      EQUIVALENCE (BETA,SPR(1))
      EQUIVALENCE (TANHL,SPR(14))
      EQUIVALENCE (TLEOB,SPR(32)),(THLOB,SPR(33)),(TTEOB,SPR(34))
      EQUIVALENCE (BCHD,SPR(18))
      EQUIVALENCE (BCLD2,SPR(13))
      EQUIVALENCE (SF,SPR(7))
      EQUIVALENCE (FTYPE,F(17))
      EQUIVALENCE (CLALDS(1),WING(241))
      EQUIVALENCE (CHAT,SPR(53)),(CHAF,SPR(54)),(AMA,SPR(55))
      EQUIVALENCE (CHABC,WING(251)),(CHDELF,SPR(56)),(CHDELR,WING(261))
      DATA ITRANS /2,3,4,7,8/
C
      IF(HTPL)GO TO 1000
      SSPNE=WINGIN(3)
      SAI000=A(59)
      SAI100=A(77)
      CHRDRE=A(10)
      CHRDTP=WINGIN(1)
      TANLE=A(62)
      TANTE=A(80)
      BO2=WINGIN(4)
      CT=WINGIN(1)
      CR=WINGIN(6)
      TAPRI=A(25)
      BSTRO2=WINGIN(2)
      TANTEO=A(104)
      TANLEO=A(86)
      CB=WINGIN(5)
      TAPRO=A(28)
      SR=SREF
      TOVC=WINGIN(18)
      TOVCO=WINGIN(66)
      CLAW=WING(101)
      GO TO 1010
 1000 SSPNE=HTIN(3)
      SAI000=AHT(59)
      SAI100=A(77)
      CHRDRE=AHT(10)
      CHRDTP=HTIN(1)
      TANLE=AHT(62)
      BO2=HTIN(4)
      CR=HTIN(6)
      TAPRI=AHT(25)
      BSTRO2=HTIN(2)
      TANTEO=AHT(104)
      TANLEO=AHT(86)
      CB=HTIN(5)
      TAPRO=AHT(28)
      SR=SREF
      TOVC=HTIN(18)
      TOVCO=HTIN(66)
      CLAW=HT(101)
      TANTE=AHT(80)
 1010 CONTINUE
      MACH=FLC(IM+2)
      BETA=SQRT(MACH**2-1.)
      NDELTA=F(16)+.5
      TRANSL=.FALSE.
      IFTYPE=FTYPE+.5
      IF(IFTYPE.NE.1)GO TO 1020
      LAMHL=ATAN(((ALOCO-ALOCI)*TAN(SAI100)+CFI-CFO)/(ALOCO-ALOCI))
      LAMHLD=LAMHL*RAD
      PHITE=2*ATAN(F(11)/COS(LAMHL))*RAD
      TANHL=TAN(LAMHL)
      TLEOB=TANLE/BETA
      THLOB=TANHL/BETA
      TTEOB=TANTE/BETA
C
C   ----RETURN IF L.E. OR T.E. OR H.L. IS SUBSONIC
C
      IF(TLEOB.GE.1.)RETURN
      IF(THLOB.GE.1.)RETURN
      IF(TTEOB.GE.1.)RETURN
      TRTOFL=CFO/CFI
      CO=CR+ALOCO*(TANTE-TANLE)
      CI=CR+ALOCI*(TANTE-TANLE)
      SPR(31)=CI
      IF(BIF.GT.(BO2-BSTRO2)) SPR(31)=CT+(BO2-BIF)*(TANLEO-TANTEO)
      MU=ARCSIN(1./MACH)
      TEMP=MU*RAD
      C1=2./BETA
      C2=(2.4*MACH**4-4.*BETA**2)/(2.*BETA**4)
      K3 =1.-(C2/C1)*(PHITE/RAD)
      K =TAN(SAI000-LAMHL)*TAN(SAI000-SAI100)
      XT=CO-CFO+(SSPNE-ALOCO)*(TANHL-TANLE)
      XR=CI+ALOCI*(TANLE-TANHL)-CFI
 1020 DO 1030 I=1,5
         IF(IFTYPE.EQ.ITRANS(I))TRANSL=.TRUE.
 1030 CONTINUE
      IF(.NOT.TRANSL)GO TO 1090
C
C*****GEOMETRIC PARAMETERS PER FLAP SEGMENT
C
      DELN4=0.25*(BOF-BIF)/BO2
      ETA(1)=BIF/BO2
      CF(1)=CFI
      ARG1=(CFI-CFO)/(4.*DELN4 )
      ARG2=(TANTE-TANLE)*BO2
      ARG3=BO2*CR
      ARG4=CR
      ARG5=TAPRI
      TC=TOVC
      IF(BIF.LT.(BO2-BSTRO2))GO TO 1040
      ARG2=(TANTEO-TANLEO)*BO2
      ARG3=BO2*CR
      ARG4=CB
      ARG5=TAPRO
      TC=TOVCO
 1040 CONTINUE
      CHRD(1)=ARG4+ETA(1)*ARG2
      SPR(31)=CHRD(1)
      CI=CHRD(1)
      DO 1050 M=2,5
         N=M-1
         ETA(M)=ETA(N)+DELN4
         CHRD(M)=ARG4+ETA(M)*ARG2
         SWF(N)=ARG3*(2.-(1.-ARG5)*(ETA(N)+ETA(M)))
 1050 CONTINUE
      DO 1080 I=1,NDELTA
         CP(1)=CPI(I)
         DO 1070 M=1,5
            IF(M.EQ.1)GO TO 1060
            ARG1=(CPI(I)-CPO(I))/(4.*DELN4)
            CP(M)=CPI(I)-ARG1*(ETA(M)-ETA(1))
 1060       CONTINUE
            N=M-1
            IF(N.EQ.0)GO TO 1070
            CPOCF(N)=(CP(M)/CHRD(M)+CP(N)/CHRD(N))/2.
            CFACTR(N)=(CPOCF(N)-1.)*SWF(N)/SR
 1070    CONTINUE
      CFACT(I)=(CFACTR(1)+CFACTR(2)+CFACTR(3)+CFACTR(4))/4.
 1080 CONTINUE
      GO TO 1310
 1090 CONTINUE
      D=CHRDRE-((ALOCI+ALOCO)/2.)*(TANLE-TANTE)
      C=(CFI+CFO)/2.
      B=D-C
      IF(ALOCI.LT.(SSPN-BSTRO2))TOVCA=TOVC
      IF(ALOCI.GT.(SSPN-BSTRO2))TOVCA=TOVCO
      G=SIN(0.5*PI-SAI000)*B/SIN(0.5*PI+SAI000-LAMHL)
      E=SIN(0.5*PI-SAI100)*C/SIN(0.5*PI+SAI100-LAMHL)
      CHRDPR=G+E
      TOVCP=TOVCA*D/CHRDPR
      XHOC=G/CHRDPR
      INBORD=.TRUE.
      IF((ALOCO/SSPN) .GE. .99)INBORD=.FALSE.
      SF=2.*((CFI+CFO)/2.)*(ALOCO-ALOCI)
      IF(TRTOFL.EQ.1.)GO TO 1100
      AFORLF=TRTOFL
      TAPERD=.TRUE.
      GO TO 1110
 1100 AFORLF=((2.*(ALOCO-ALOCI))**2)/SF*BETA
      TAPERD=.FALSE.
 1110 CONTINUE
C
      CALL DFLCON(THLOB,TTEOB,AFORLF,BETA,INBORD,TAPERD)
C
      PIO2=PI/2.
      I=0
      DO 1300 II=1,2
         I=I+1
         Y=I
         IF(I.EQ.2)GO TO 1120
C
C    *** TIP CHARACTERISTICS ***
C
         V1=ALOCI
         V2=CI
         V3=CFI
         V4=ALOCO
         V5=CO
         V6=CFO
         V7=SSPNE
         GO TO 1130
C
C    *** ROOT CHARACTERISTICS ***
C
 1120    V1=ALOCO
         V2=CO
         V3=CFO
         V4=ALOCI
         V5=CI
         V6=CFI
         V7=0.
C
C     FINDING ALPHA1 THRU ALPHA4
C
 1130    XYZ=V7-V1
         IF(I.EQ.2) XYZ=-XYZ
         ZYX=V7-V4
         IF(I.EQ.2) ZYX=-ZYX
         ARG1=V1*TANLE+V2-V3-V7*TANLE
         IF(ARG1.EQ.0.) GO TO 1140
         ALPHA1=ATAN(XYZ/ARG1)
         IF(ALPHA1.LT.0.) ALPHA1=PI+ALPHA1
         GO TO 1150
 1140    ALPHA1=PIO2
 1150    ARG1=V1*TANLE+V2-V7*TANLE
         IF(ARG1.EQ.0.) GO TO 1160
         ALPHA2=ATAN(XYZ/ARG1)
         IF(ALPHA2.LT.0.) ALPHA2=PI+ALPHA2
         GO TO 1170
 1160    ALPHA2=PIO2
 1170    ARG1=V4*TANLE+V5-V6-V7*TANLE
         IF(ARG1.EQ.0.) GO TO 1180
         ALPHA3=ATAN(ZYX/ARG1)
         IF(ALPHA3.LT.0.) ALPHA3=PI+ALPHA3
         GO TO 1190
 1180    ALPHA3=PIO2
 1190    ARG1=V4*TANLE+V5-V7*TANLE
         IF(ARG1.EQ.0.) GO TO 1200
         ALPHA4=ATAN(ZYX/ARG1)
         IF(ALPHA4.LT.0.) ALPHA4=PI+ALPHA4
         GO TO 1210
 1200    ALPHA4=PIO2
 1210    IF(MU.GT.ALPHA1)KASENO=1
         IF(MU.LE.ALPHA1.AND.MU.GT.ALPHA2.AND.MU.GT.ALPHA3)KASENO=2
         IF(MU.LE.ALPHA2.AND.MU.GT.ALPHA3)KASENO=3
         IF(MU.LE.ALPHA3.AND.MU.GT.ALPHA2)KASENO=4
         IF(MU.LE.ALPHA2.AND.MU.LT.ALPHA3.AND.MU.GT.ALPHA4)KASENO=5
         IF(MU.LE.ALPHA4)KASENO=6
         IF(I.EQ.1)GO TO 1220
         IF(TANLE.EQ.0.0)SPAMT=0.
         IF(TANLE.EQ.0.0)GO TO 1280
C
C    *** ROOT CHARACTERISTICS ***
C
         X1=CHRDRE
         X4=XR
         X5=ALOCO
         X6=ALOCI
         X7=1.-TTEOB
         X8=1.-THLOB
         X9=-TTEOB
         X10=-THLOB
         GO TO 1230
C
C    *** TIP CHARACTERISTICS ***
C
 1220    X1=CHRDTP
         X4=XT
         X5=SSPNE-ALOCI
         X6=SSPNE-ALOCO
         X7=1.+TTEOB
         X8=1.+THLOB
         X9=TTEOB
         X10=THLOB
 1230    SPAMT=0.
         PAM1=0.
         PAM2=0.
         PAM3=0.
         PAM4=0.
         PAM5=0.
         PAM6=0.
         PAM7=0.
         PAM8=0.
         IF(KASENO.EQ.6)GO TO 1280
C
C    ***** AREA 3 *****
C
         R3=1.-(BETA*X6*X7)/X1
         CALL PTCP(R3,Y,3,P3,TCP3)
         PAM3=R3*P3*X1**2*(1./(BETA*X7))*(2.*X1*(1.+X10*TCP3)/(1.+X9*
     1        TCP3)-3.*X4)
C
C    ***** AREA 7 *****
C
         R7=X1/(BETA*X6)-X7
         CALL PTCP(R7,Y,7,P7,TCP7)
         PAM7=R7*P7*BETA*X6**2*(3.*X4-2.*BETA*X6*(1.+X10*TCP7)/TCP7)
         SPAMT=PAM3+PAM7
         IF(KASENO.EQ.5)GO TO 1280
         IF(KASENO.LT.4)GO TO 1240
C
C    ***** AREA 1 *****
C
         R1=X1/(BETA*X5)-X7
         CALL PTCP(R1,Y,1,P1,TCP1)
         PAM1=R1*P1*BETA*X5**2*(2.*BETA*X5*(1.+X10*TCP1)/TCP1-3.*X4)
C
C    ***** AREA 4 *****
C
         R4=1.-BETA*X5*X7/X1
         CALL PTCP(R4,Y,4,P4,TCP4)
         PAM4=R4*P4*X1**2*(1./(BETA*X7))*(3.*X4-2.*X1*(1.+X10*TCP4)/
     1        (1.+X9*TCP4))
         SPAMT=SPAMT+PAM1+PAM4
         GO TO 1280
 1240 CONTINUE
C
C    ***** AREA 5 *****
C
         R5=1.-BETA*X6*X8/X4
         CALL PTCP(R5,Y,5,P5,TCP5)
         PAM5=R5*P5*X4**3*(1./(BETA*X8))
C
C    ***** AREA 8 *****
C
         R8=X4/(BETA*X6)-X8
         CALL PTCP(R8,Y,8,P8,TCP8)
         PAM8=R8*P8*BETA*X6**2*(2.*BETA*X6*(1.+X10*TCP8)/TCP8-3.*X4)
         SPAMT=SPAMT+PAM5+PAM8
         IF(KASENO.LT.3)GO TO 1250
         GO TO 1260
C
C    ***** AREA 1 *****
C
 1250    R1=X1/(BETA*X5)-X7
         CALL PTCP(R1,Y,1,P1,TCP1)
         PAM1=R1*P1*BETA*X5**2*(2.*BETA*X5*(1.+X10*TCP1)/TCP1-3.*X4)
C
C    ***** AREA 4 *****
C
         R4=1.-BETA*X5*X7/X1
         CALL PTCP(R4,Y,4,P4,TCP4)
         PAM4=R4*P4*X1**2*(1./(BETA*X7))*(3.*X4-2.*X1*(1.+X10*TCP4)/
     1        (1.+X9*TCP4))
         SPAMT=SPAMT+PAM1+PAM4
 1260    IF(KASENO.LT.2)GO TO 1270
         GO TO 1280
C
C    ***** AREA 2 *****
C
 1270    R2=X4/(BETA*X5)-X8
         CALL PTCP(R2,Y,2,P2,TCP2)
         PAM2=R2*P2*BETA*X5**2*(3.*X4-2.*BETA*X5*(1.+X10*TCP2)/TCP2)
C
C    ***** AREA 6 *****
C
         R6=1.-BETA*X5*X8/X4
         CALL PTCP(R6,Y,6,P6,TCP6)
         PAM6=-R6*P6*X4**3*(1./(BETA*X8))
         SPAMT=SPAMT+PAM2+PAM6
 1280    CONTINUE
         IF(I.EQ.2)GO TO 1290
         SPAMI=SPAMT
         SPR(37)=PAM1
         SPR(38)=PAM2
         SPR(39)=PAM3
         SPR(40)=PAM4
         SPR(41)=PAM5
         SPR(42)=PAM6
         SPR(43)=PAM7
         SPR(44)=PAM8
         GO TO 1300
 1290    SPAMR=SPAMT
         SPR(45)=PAM1
         SPR(46)=PAM2
         SPR(47)=PAM3
         SPR(48)=PAM4
         SPR(49)=PAM5
         SPR(50)=PAM6
         SPR(51)=PAM7
         SPR(52)=PAM8
 1300 CONTINUE
C
C    **** SUPERSONIC HINGE MOMENT DERIVATIVE FOR FLAT SIDED CONTROLS ***
C
      CHAT=(-2./(RAD*BETA*SQRT(1.-TLEOB**2)))*(1.-(SPAMT+SPAMR)/
     1     ((ALOCO-ALOCI)*(CFI**2+CFI*CFO+CFO**2)))
      CHAF=K3*CHAT
C
C    **** AREA MOMENT ABOUT HINGE LINE ****
C
      AMA=(CFI*(ALOCO-ALOCI)/6.)*COS(LAMHL)*((CFO/CFI)**2+CFO/CFI+1.)
C
C    **** SUPERSONIC HINGE MOMENT DERIVATIVE FOR ****
C         SYMMETRIC BI-CONVEX AIRFOILS
C
      CHABC=CHAT*(1.-(.666667*C2*TOVCP/(C1*(1+K)*COS(SAI000-LAMHL)))*(2.
     1      *(1.+2.*XHOC)-K*(1.-XHOC)**2))
C
C   ** SUPERSONIC HINGE MOMENT DERIVATIVE FOR FLAT CONTROLS WRT DELTA **
C
      CHDELF=K3*BCHD
C
C    **** SUPERSONIC HINGE MOMENT DERIVATIVE FOR SYMMETRIC ****
C         BI-CONVEX AIRFOIL CONTROLS
C
      CHDELR=(1.-1.33333*(C2/C1)*TOVCP*(1.+2.*XHOC))*BCHD
      IF(.NOT.TRANSL)GO TO 1330
 1310 DO 1320 I=1,NDELTA
         CLALDS(I)=CLAW*(1.+CFACT(I))+CLAW
 1320 CONTINUE
 1330 CONTINUE
      CALL SSSYM
      RETURN
      END
