      SUBROUTINE SUPCM0
C
C***  CALCULATES SUPERSONIC CONFIGURATION  CM0
C
      COMMON /IBW/    PBW,    BW(380)
      COMMON /IBH/    PBH,    BH(380)
      COMMON /FLGTCD/ FLC(160)
      COMMON /SUPBOD/ SBD(229)
      COMMON /SYNTSS/ XCG, XW, ZW, ALIW, ZCG, XH, ZH, ALIH, XV,
     1                VERTUP, HINAX, XVF, SCALE, ZV, ZVF, YV, YF,
     2                PHIV, PHIF
      COMMON /WINGI/  WGIN(101)
      COMMON /HTI/    HTIN(154)
      COMMON /BDATA/  BD(762)
      COMMON /WINGD/  A(195), B(49)
      COMMON /SBETA/  STB(135), TRA(108), TRAH(108), STBH(135)
      COMMON /HTDATA/ AHT(195), BHT(49)
      COMMON /OVERLY/ NLOG,NMACH,I,NALPHA,IG,NF,LF,K
      COMMON /FLOLOG/ FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1                HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2                TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3                HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4                VFPL,VFSC,CTAB
C
      EQUIVALENCE (BW(41),CMOWB), (BH(41),CMOHB)
      LOGICAL  FLTC,OPTI,BO,WGPL,WGSC,SYNT,HTPL,HTSC,VTPL,VTSC,
     1         HEAD,PRPOWR,JETPOW,LOASRT,TVTPAN,SUPERS,SUBSON,
     2         TRANSN,HYPERS,SYMFP,ASYFP,TRIMC,TRIM,DAMP,
     3         HYPEF,TRAJET,BUILD,FIRST,DRCONV,PART,
     4         VFPL,VFSC,CTAB
C
C***  WING-BODY CMO
C
      IF(.NOT. WGPL) GO TO 1010
      DB  = 2.0*(WGIN(4)-WGIN(3))
      XLN = (XW+0.5*DB*A(38))/DB
      XLA = (XW+WGIN(6)+0.5*DB*A(80))/DB
      XLA = BD(1)/DB-XLA
      RN  = FLC(I+2)*A(122)
      DBM = SBD(120)
      WL  = 0.5*ZW/DBM
      VT  = 0.0
      HD  = 0.0
      DOB = 0.5*DBM/WGIN(4)
      CALL WBCM0(A(120), A(38), WGIN(16), XLN, XLA, A(118), WGIN(62),
     1      WGIN(11), WGIN(93), WGIN(94), RN, FLC(96), WL,
     2      VT, HD, DOB, FLC(I+2), CMOWB)
      TRA(73) = CMOWB
 1010 CONTINUE
C
C***  HORIZONTAL-BODY CMO
C
      IF(.NOT. HTPL) GO TO 1020
      DB  = 2.0*(HTIN(4)-HTIN(3))
      XLN = (XH+0.5*DB*AHT(38))/DB
      XLA = (XH+HTIN(6)+0.5*DB*AHT(80))/DB
      XLA = BD(1)/DB-XLA
      RN  = FLC(I+2)*AHT(122)
      DBM = SBD(120)
      WL  = 0.5*ZW/DBM
      VT  = 0.0
      HD  = 0.0
      DOB = 0.5*DBM/HTIN(4)
      CALL WBCM0(AHT(120), AHT(38), HTIN(16), XLN, XLA, AHT(118),
     1      HTIN(62),HTIN(11), HTIN(93), HTIN(94), RN, FLC(96), WL,
     2      VT, HD, DOB, FLC(I+2), CMOHB)
      TRAH(73) = CMOHB
 1020 CONTINUE
      RETURN
      END
