      SUBROUTINE THEORY
C
C***  MAIN LOGIC ROUTINE FOR CALCULATING AIRFOIL CHARACTERISTICS
C
      COMMON /IBODY/  PB, NACA(80), BF(232), CBAR
      COMMON /FLGTCD/ FLC(93)
      COMMON / IBH /  PBH, THN(60),CAM(60),A0,XC,MCC,CLCC,XAC(20)
      COMMON /IBWH/   PBWH,AI,ALO,CLI,ASEP,CMCO4,CLA0,CLA(20)
      COMMON /IBWHV/  PBWHV, RHO,TMAX,DELTAY
      COMMON /CONSNT/ PI,DEG,UNUSED,RAD
      INTEGER A4HW,A4HH,A4HV,A4HF
      LOGICAL CRIT,FLAG
      REAL MACH,MCC
      DATA A4HW,A4HH,A4HV,A4HF/4HW   ,4HH   ,4HV   ,4HF   /
C
C  CALCULATE THE SECTION AERODYNAMICS
C
      FLAG=.FALSE.
      CALL IDEAL
      MACH = 0.0
      RENN = 0.0
      CALL SLOPE(MACH,CLA0,RENN,XACO)
      WRITE(6,1020)
      IF(NACA(6).EQ.A4HW)WRITE(6,1030)
      IF(NACA(6).EQ.A4HH)WRITE(6,1040)
      IF(NACA(6).EQ.A4HV)WRITE(6,1050)
      IF(NACA(6).EQ.A4HF)WRITE(6,1060)
      WRITE(6,1070)AI,ALO,CLI,CMCO4,CLA0,RHO,TMAX,DELTAY
C
C  CALCULATE THE LIFT CURVE SLOPE AT MACH NUMBER, CM AND XAC
C
      NMACH=FLC(1) + 0.5
      CRIT=.FALSE.
      DO 1010 I=1,NMACH
         MACH=FLC(I+2)
         RENN=FLC(I+42)*CBAR
         IF(MACH .GE. MCC) CRIT=.TRUE.
         IF(CLA(I) .NE. UNUSED) GO TO 1010
         IF(MACH .GE. MCC) CLA(I)=CLCC
         IF(CRIT) GO TO 1010
         CALL SLOPE(MACH,CLA(I),RENN,XAC(I))
         IF(CLA(I).NE.UNUSED) GO TO 1000
         FLAG=.TRUE.
         WRITE(6,1110) MACH
         GO TO 1010
 1000    WRITE(6,1080) MACH,CLA(I),XAC(I)
 1010 CONTINUE
      IF(CRIT) WRITE(6,1090) MCC,XC,CLCC
      IF(FLAG) CALL EXIT
 1020 FORMAT(1H1,29X,75HAUTOMATED STABILITY AND CONTROL METHODS PER APRI
     1L 1976 VERSION OF DATCOM    )
 1030 FORMAT(1H ,55X,23HWING SECTION DEFINITION)
 1040 FORMAT(1H ,50X,34HHORIZONTAL TAIL SECTION DEFINITION)
 1050 FORMAT(1H ,51X,32HVERTICAL TAIL SECTION DEFINITION)
 1060 FORMAT(1H ,52X,30HVENTRAL FIN SECTION DEFINITION)
 1070 FORMAT(1H0,33X,23HIDEAL ANGLE OF ATTACK =,F10.5,5H DEG.//
     1   30X,27HZERO LIFT ANGLE OF ATTACK =,F10.5,5H DEG.//
     2   33X,24HIDEAL LIFT COEFFICIENT =,F10.5//
     3   18X,39HZERO LIFT PITCHING MOMENT COEFFICIENT =,F10.5//
     4   29X,28HMACH ZERO LIFT-CURVE-SLOPE =,F10.5,6H /DEG.//
     5   36X,21HLEADING EDGE RADIUS =,F10.5,15H FRACTION CHORD//
     6   30X,27HMAXIMUM AIRFOIL THICKNESS =,F10.5,15H FRACTION CHORD//
     7   48X, 9HDELTA-Y =,F10.5,14H PERCENT CHORD//)
 1080 FORMAT(1H0,25X,5HMACH=,F7.4,19H LIFT-CURVE-SLOPE =,F10.5,
     1   6H /DEG.,5X,6H XAC =,F10.5)
 1090 FORMAT(1H0,36X,43H*** CREST CRITICAL MACH NUMBER EXCEEDED ***//
     1 35X,22H CREST CRITICAL MACH =,F10.5//
     2 46X,11H LOCATION =,F10.5,15H FRACTION CHORD//
     3 38X,19H LIFT-CURVE-SLOPE =,F10.5,6H /DEG.)
 1110 FORMAT(   1X,69H     AIRFOIL MODULE UNABLE TO CALCULATE SECTION CL
     1ALPA FOR MACH NO = ,F7.3,50H  THEREFORE A VALUE MUST BE SPECIFIED
     2BY THE USER./1X,123H     SEE USERS MANUAL FOR SECTION CHARACTERIST
     3ICS INPUT.  (NOTE% CLALPA AND CLMAX SHOULD REFERENCE FOOTNOTE 1 ON
     4 PAGE 29. )/)
      RETURN
      END
