      SUBROUTINE VFCDO(I)
C
C***  CALCULATES VENTRAL FIN ZERO LIFT DRAG COEFFICIENT
C
      REAL MACH,LERBW,LERO,LERI,KSHARP
      DIMENSION ROUTID(2)
      DIMENSION Q15127(4)
      DIMENSION WTYPE(4),CN(20),CAV(20),CDJWB(20), CLJWB(20),CD(20)
      DIMENSION X27M(4),X27I(4),C27(6)
C
      COMMON /OVERLY/ NLOG,NMACH,M,NALPHA
      COMMON /CONSNT/ PI,DEG,UNUSED,RAD
      COMMON /OPTION/ SR,CBARR,RUFF,BLREF
      COMMON /VTI/    VTIN(162),CT,SPANO,SPANS,SSPN,CB,CR,SAVSI,SAVSO,
     1                CHSTAT,SWAFP,TWISTA,SSPNDD,DHDADI,DHDADO,
     2                TYPE,
     3                TOVC,DELTAY,XOVC,CLI,ALPHAI,CLALPA(20),
     4                CLMAX(20),CMO,LERI,LERO,CAMBER,TOVCO,XOVCO,CMOT,
     5               CLMAXL,CLAMO,TCEFF,KSHARP,SVWB(20),SVB(20),SVHB(20)
      COMMON /WINGD/  A(195)
      COMMON /VTDATA/ AAA(195),AVT(195)
      COMMON /WBHCAL/ STP(156)
      COMMON /IBW/    PBW, BW(380)
      COMMON /IBWV/   PBWV, BWV(380)
      COMMON /FLGTCD/ FLC(160)
C
      EQUIVALENCE (CDO,STP(156)),(CD(1),BWV(1)),(CN(1),BWV(61)),
     1            (CAV(1),BWV(81))
      EQUIVALENCE (CBARI,AVT(15)),(RNFS,A(129)),(SRSTAR,AVT(3)),
     1            (CBARO,AVT(17)),(SISTAR,AVT(1)),(SOSTAR,AVT(2)),
     2            (TANLEO,AVT(86)),(COSLEO,AVT(85)),(TANLEI,AVT(62)),
     3            (COSLE,AVT(61)),(TANTEO,AVT(104)),(CDJWB(1),BW(1)),
     4            (CLJWB(1),BW(21))
C
      DATA ROUTID /4HVFCD,4HO   /
      DATA Q15127 /4H4.1.,4H5.1-,4H27  ,4HCEPT/
      DATA WTYPE  /4HSTRA,4HDOUB,4HCRAN,4HCURV/
      DATA X27M   /0.0,1.0,2.0,3.0/
      DATA X27I   /1.57780,1.67221,1.98509,2.28874/
      DATA I27    /0/
C
      MACH=FLC(I+2 )
      BETA=SQRT(MACH**2-1.0)
C
C  ***WING SUPERSONIC ZERO-LIFT SKIN FRICTION DRAG,STRAIGHT TAPERED WING
C
      IF(TYPE.NE.WTYPE(1))GO TO 1020
      CBAR=CBARI
 1000 RNN=CBAR*RNFS
      IF(RUFF.EQ.0.0)GO TO 1010
      ARG=12.*CBAR/RUFF
C
C                   FIGURE 4.1.5.1-27 (EQUATION FOR RLCOFF)
C
      RACH = MACH
      IF(RACH.GT.3.0)RACH=3.0
      CALL TBFUNX(RACH,CEPT,DYDX,4,X27M,X27I,C27,I27,MI,NG,
     1            0,0,Q15127,4,ROUTID)
      RLCOFF=ARG**1.0482*10.0**CEPT
      IF(RLCOFF.LT.RNN)RNN=RLCOFF
 1010 CALL FIG26(RNN,RACH,CF)
      IF(TYPE.NE.WTYPE(1))GO TO 1030
      CDF=CF*SRSTAR/SR*2.
      GO TO 1050
C
C  ***WING SUPERSONIC ZERO-LIFT SKIN FRICTION DRAG,NON-STRAIGHT WING***
C
 1020 CONTINUE
      CBAR=CBARI
      GO TO 1000
 1030 CONTINUE
      IF(CBAR.EQ.CBARO)GO TO 1040
      RNI=RNN
      CFI=CF
      CBAR=CBARO
      GO TO 1000
 1040 RNO=RNN
      CFO=CF
      CDF=(CFI*SISTAR+CFO*SOSTAR)/SR*2.
 1050 CONTINUE
C
C   ***SUPERSONIC WING ZERO-LIFT WAVE DRAG,SHARP L.E.,ALL PLANFORMS***
C
      IF(TYPE.EQ.WTYPE(1))GO TO 1060
      TA=TANLEO
      SPANIN=SPANS-SPANO
      CRBW=CB+SPANIN*(TANLEO-TANTEO)
      SBW=(CRBW+CT)*SPANS*0.50
      S=SBW
      CA=COSLEO
      LERBW=LERO*((CR+CT+2.*CB)/4.)
      GO TO 1070
 1060 TA=TANLEI
      IF(ABS(TA) .LT. UNUSED) TA = UNUSED
      S=(CR+CT)/2.*SSPN
      CA =COSLE
      LERBW=LERI*((CR+CT)/2.)
 1070 CONTINUE
      BOVERT=BETA/TA
      IF(KSHARP.EQ.UNUSED)GO TO 1080
      ARG=KSHARP*TCEFF**2*S  /SR
      CDW=ARG/BETA
      IF(BOVERT.LT.1.)CDW=ARG/TA
      GO TO 1090
 1080 CONTINUE
C
C  ***SUPERSONIC WING ZERO-LIFT WAVE DRAG,ROUND L.E.,ALL PLANFORMS***
C
      ARG1=1.28*MACH**3*CA    **6/(1.+MACH**3*CA    **3)
      ARG2=2.* LERBW * SPANS /(SR*CA)
      CDLE=ARG1*ARG2
      ARG=     16.*TCEFF**2*S  /(3.*SR)
      IF(BOVERT.GE.1.)CDW=CDLE+ARG/BETA
      IF(BOVERT.LT.1.)CDW=CDLE+ARG/TA
 1090 CONTINUE
      CDO=CDF+CDW
      IF(TYPE.NE.WTYPE(1))RETURN
      DO 1100 J=1,NALPHA
         CD(J)=CD(J)+CDO
         COSA=COS(FLC(J+22)/RAD)
         SINA=SIN(FLC(J+22)/RAD)
         CN(J)=CLJWB(J)*COSA+CD(J)*SINA
 1100 CAV(J)=CD(J)*COSA-CLJWB(J)*SINA
      RETURN
      END
