      SUBROUTINE XYCORD(IVAL,INT)
C
C  CALCULATE MEAN LINE AND THICKNESS DISTRIBUTION FROM X,Y COORDINATES
C
      COMMON /IBODY/ PB,NACA(80)
      COMMON /IWING/ PW, X(60)
      COMMON / IHT / PHT, XU(60),XL(60),YU(60),YL(60)
      COMMON / IBW / PBW, N
      COMMON / IVT / PVT, YUN(60),YLN(60)
      COMMON / IBH / PBH, THN(60),CAM(60)
      COMMON /IBWHV/ PBWHV, RHO,TMAX
      DIMENSION ROUT(2),C(6)
      REAL NACA
      DATA ROUT /4HXYCO, 4HRD  /
      DATA A4W,A4H,A4V,A4F/4HW   ,4HH   ,4HV   ,4HF   /
      IF(IVAL.NE.0) GO TO 1010
      DO 1000 I=1,N
         THN(I)=0.5*(YU(I)-YL(I))
         CAM(I)=0.5*(YU(I)+YL(I))
 1000 CONTINUE
 1010 THN(1)=0.0
      THN(N)=0.0
      CAM(1)=0.0
      CAM(N)=0.0
      IN=0
      DO 1020 I=1,N
         CALL TBFUNX(X(I),Y,DYDX,N,X,CAM,C,IN,MI,NG,0,0,4HDCAM,1,ROUT)
         THETA=ATAN(DYDX)
         SA=SIN(THETA)
         CA=COS(THETA)
         XU(I)=X(I)-THN(I)*SA
         XL(I)=X(I)+THN(I)*SA
         YUN(I)=CAM(I)+THN(I)*CA
         YLN(I)=CAM(I)-THN(I)*CA
 1020 CONTINUE
      XU(1)=0.0
      XL(1)=0.0
      XU(N)=1.0
      XL(N)=1.0
      YUN(1)=0.0
      YUN(N)=0.0
      YLN(1)=0.0
      YLN(N)=0.0
      IF(INT.EQ.0)RETURN
C
C  DOUBLE THICKNESS TO REFLECT USER INPUTS
C
      DO 1030 I=1,N
 1030 THN(I)=2.*THN(I)
      WRITE(6,1050)
      IF(INT.EQ.1)WRITE(6,1060)
      IF(INT.EQ.2)WRITE(6,1061)
      IF(INT.EQ.3)WRITE(6,1062)
      IF(INT.EQ.4)WRITE(6,1063)
      IF(INT.EQ.1)NACA(6)=A4W
      IF(INT.EQ.2)NACA(6)=A4H
      IF(INT.EQ.3)NACA(6)=A4V
      IF(INT.EQ.4)NACA(6)=A4F
      WRITE(6,1070)
      WRITE(6,1080)(XU(M),YUN(M),XL(M),YLN(M),X(M),CAM(M),THN(M),
     1              M=1,N)
C
C  NOW HALVE THICKNESS FOR PROGRAM COMPUTATIONS
C
      DO 1040 I=1,N
 1040 THN(I)=.5*THN(I)
 1050 FORMAT(1H1,29X,75HAUTOMATED STABILITY AND CONTROL METHODS PER APRI
     1L 1976 VERSION OF DATCOM     )
 1060 FORMAT(1H ,55X,25HUSER DEFINED WING SECTION)
 1061 FORMAT(1H ,50X,36HUSER DEFINED HORIZONTAL TAIL SECTION)
 1062 FORMAT(1H ,50X,35HUSER DEFINED VERTICAL TAIL SECTION )
 1063 FORMAT(1H ,51X,34HUSER DEFINED VENTRAL FIN SECTION  )
 1070 FORMAT(1H ,3X,15H UPPER ABSCISSA,4X,15H UPPER ORDINATE,4X,
     1              15H LOWER ABSCISSA,4X,15H LOWER ORDINATE,6X,
     2              16HX-FRACTION CHORD,4X,9HMEAN LINE,4X,9HTHICKNESS)
 1080 FORMAT(8X,F8.5,11X,F8.5,10X,F8.5,10X,F8.5,13X,F8.5,10X,
     1       F8.5,6X,F8.5)
      RETURN
      END
